; --------------------------------------------------------------------------
; FILE: t89c51cc01.i51 - ATMEL T89C51CC01 register and bit names
; Copyright (C) 2002 by Stephen Moraco, KC0FTQ
; $Id: t89c51cc01.i51,v 1.13 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
; This program is free software; you can redistribute it and/or 
; modify it under the terms of the GNU General Public License as published
; by the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; -------------------------------------------------------------------------

;----------------------------------------
; Include file for 8051 SFR Definitions
;----------------------------------------

;  BYTE Register
;.equ   P0, 080H
.equ    DATAIN, P0
;   bit renames for AMSAT CAN Module actual use
.flag   IN7, P0.7
.flag   IN6, P0.6
.flag   IN5, P0.5
.flag   IN4, P0.4
.flag   IN3, P0.3
.flag   IN2, P0.2
.flag   IN1, P0.1
.flag   IN0, P0.0

;.equ   P1, 090H
;   bit renames for AMSAT CAN Module actual use
.flag   AN7, P1.7
.flag   LT1787, P1.7    ; LT1787HVHS8 - current sensor
.flag   AN6, P1.6
.flag   LM60, P1.6      ; LM60CIM     - temperature sensor
.flag   AN5, P1.5
.flag   BIAS, P1.5      ; VREF TAP    - divider monitor
.flag   AN4, P1.4
.flag   INREQ, P1.4     ; Module requests to send another byte
.flag   AN3, P1.3
.flag   AN2, P1.2
.flag   AN1, P1.1
.flag   AN0, P1.0
.flag   OUTACK, P1.0    ; Module has recv'd latest byte

;.equ   P2, 0A0H
.equ    DATAOUT, P2
;   bit renames for AMSAT CAN Module actual use
.flag   OUT7, P2.7
.flag   OUT6, P2.6
.flag   OUT5, P2.5
.flag   OUT4, P2.4
.flag   OUT3, P2.3
.flag   OUT2, P2.2
.flag   OUT1, P2.1
.flag   OUT0, P2.0

;.equ   P3, 0B0H
.flag   RD, P3.7
.flag   WR, P3.6
.flag   T1, P3.5
.flag   T0, P3.4
.flag   INT1, P3.3
.flag   INT0, P3.2
.flag   TXD, P3.1
.flag   RXD, P3.0
;   bit renames for AMSAT CAN Module actual use
.flag   PWRCTRL, P3.7
.flag   SR_LOAD, P3.6   ; PL-BAR
.flag   SR_CLK, P3.5    ; CLK
.flag   SR_DATA, P3.4   ; Q7 (NOT Q7-BAR!)
.flag   OUT11, P3.3
.flag   INACK, P3.3
.flag   MX_STROBE, P3.3
.flag   OUT10, P3.2
.flag   OUTREQ, P3.2
.flag   MX_LATCH2, P3.2
.flag   OUT9, P3.1
.flag   MX_LATCH1, P3.1
.flag   OUT8, P3.0
.flag   MX_LATCH0, P3.0

.equ    P3MSK_BUT_LATCH,0xff-0x07
;
; NOTE: SR_* are control and data lines for 74HC165 Shift Register
;  the data bits are mapped as follows:
;
;   SR   PURPOSE - PIN
;  ---- ---------------
;   D7     MODE1 - JP1
;   D6     MODE0 - JP2
;   D5        A5 - JP3
;   D4        A4 - JP4
;   D3        A3 - JP5
;   D2        A2 - JP6
;   D1        A1 - JP7
;   D0        A0 - JP8
;  ---- ---------------

.equ    P4, 0C0H
.flag   RXDC, P4.1  ; CAN data in
.flag   TXDC, P4.0  ; CAN data out

;.equ   PSW, 0D0H
.flag   CY, PSW.7
.flag   AC, PSW.6
.flag   F0, PSW.5
.flag   RS1, PSW.4
.flag   RS0, PSW.3
.flag   OV, PSW.2
.flag   F1, PSW.1
.flag   P, PSW.0

;.equ   ACC, 0E0H
;.equ   B, 0F0H
;.equ   SP, 081H
;.equ   DPL, 082H
;.equ   DPH, 083H

;------------------ Power Control register ---------------------
;.equ   PCON, 087H  ; NOT bit addressable!!!
;.flag  SMOD1, PCON.7
;.flag  SMOD0, PCON.6
;.flag  POF, PCON.4
;.flag  GF1, PCON.3
;.flag  GF0, PCON.2
;.flag  PD, PCON.1
;.flag  IDL, PCON.0

;------------------ Clock Control Register ---------------------
.equ    CKCON, 08FH ; NOT bit addressable!!!
;.flag  CANX2, CKCON.7
;.flag  WDX2, CKCON.6
;.flag  PCAX2, CKCON.5
;.flag  SIX2, CKCON.4
;.flag  T2X2, CKCON.3
;.flag  T1X2, CKCON.2
;.flag  T0X2, CKCON.1
;.flag  X2, CKCON.0

;------------------ TIMER Control Registers ---------------------
;.equ   TCON, 088H
.flag   TF1, TCON.7
.flag   TR1, TCON.6
.flag   TF0, TCON.5
.flag   TR0, TCON.4
.flag   IE10, TCON.3
.flag   IT1, TCON.2
.flag   IE00, TCON.1
.flag   IT0, TCON.0

;.equ   TMOD, 089H

;.equ   T2CON, 0C8H
.flag   TF2, T2CON.7
.flag   EXF2, T2CON.6
.flag   RCLK, T2CON.5
.flag   TCLK, T2CON.4
.flag   EXEN2, T2CON.3
.flag   TR2, T2CON.2
.flag   C_T2, T2CON.1
.flag   CP_RL2, T2CON.0

.equ    T2MOD, 0C9H
;.equ   TL0, 08AH
;.equ   TL1, 08BH
;.equ   TL2, 0CCH
;.equ   TH0, 08CH
;.equ   TH1, 08DH
;.equ   TH2, 0CDH
;.equ   RCAP2L, 0CAH
;.equ   RCAP2H, 0CBH
.equ    WDTRST, 0A6H
.equ    WDTPRG, 0A7H

;------------------- UART Control Registers ------------------------
;.equ   SCON, 098H
.flag   SM0, SCON.7
.flag   FE, SCON.7
.flag   SM1, SCON.6
.flag   SM2, SCON.5
.flag   REN, SCON.4
.flag   TB8, SCON.3
.flag   RB8, SCON.2
.flag   TI, SCON.1
.flag   RI, SCON.0

;.equ   SBUF, 99H
.equ    SADEN, 0B9H
.equ    SADDR, 0A9H

;-------------------- ADC Control Registers ----------------------
.equ    ADCLK, 0F2H ; NOT bit addressable
.equ    ADCON, 0F3H
.equ    ADDL, 0F4H
.equ    ADDH, 0F5H
.equ    ADCF, 0F6H

;-------------------- FLASH Control Registers ------------
.equ    FPGACON, 0F1H   ; NOT bit addressable
.equ    FCON, 0D1H

;-------------------- EEPROM Control Registers ------------
.equ    EECON, 0D2H ; NOT bit addressable

;-------------------- Auxilliary Control Registers ------------
.equ    AUXR, 08EH  ; NOT bit addressable
.equ    AUXR1, 0A2H

;-------------------- Interrupt Control Registers -----------------------
.equ    IPL1, 0F8H  ; bit addressable
; bits IPL1 7..3 reserved
.flag   POVRL, IPL1.2
.flag   PADCL, IPL1.1
.flag   PCANL, IPL1.0

.equ    IPL0, 0B8H
; bit IPL0 7 reserved
.flag   PPC, IPL0.6
.flag   PT2, IPL0.5
.flag   PS, IPL0.4
.flag   PT1, IPL0.3
.flag   PX1, IPL0.2
.flag   PT0, IPL0.1
.flag   PX0, IPL0.0

.equ    IPH1, 0F7H  ; NOT bit addressable
.equ    IPH0, 0B7H

;  IEn0
.equ    IEN0, 0A8H  ; bit addressable
.flag   EA, IEN0.7
.flag   EC, IEN0.6
.flag   ET2, IEN0.5
.flag   ES, IEN0.4
.flag   ET1, IEN0.3
.flag   EX1, IEN0.2
.flag   ET0, IEN0.1
.flag   EX0, IEN0.0

;  IEn1
.equ    IEN1, 0E8H  ; bit addressable
.flag   ETIM, IEN1.2
.flag   EADC, IEN1.1
.flag   ECAN, IEN1.0

;--------------------- PCA Control Registers --------------------
.equ    CCON, 0D8H  ; bit addressable
.flag   CF, CCON.7
.flag   CR, CCON.6
;.flag  -, CCON.5
.flag   CCF4, CCON.4
.flag   CCF3, CCON.3
.flag   CCF2, CCON.2
.flag   CCF1, CCON.1
.flag   CCF0, CCON.0

.equ    CMOD, 0D9H  ; NOT bit addressable
.equ    CH, 0F9H
.equ    CL, 0E9H
.equ    CCAP0H, 0FAH
.equ    CCAP0L, 0EAH
.equ    CCAPM0, 0DAH
.equ    CCAP1H, 0FBH
.equ    CCAP1L, 0EBH
.equ    CCAPM1, 0DBH
.equ    CCAP2H, 0FCH
.equ    CCAP2L, 0ECH
.equ    CCAPM2, 0DCH
.equ    CCAP3H, 0FDH
.equ    CCAP3L, 0EDH
.equ    CCAPM3, 0DDH
.equ    CCAP4H, 0FEH
.equ    CCAP4L, 0EEH
.equ    CCAPM4, 0DEH

;------------------- CAN Control Registers --------------------------
.equ    CANGIT, 09BH    ; NOT bit addressable
.equ    CANTEC, 09CH
.equ    CANREC, 09DH
.equ    CANTCON, 0A1H
.equ    CANMSG, 0A3H
.equ    CANTTCL, 0A4H
.equ    CANTTCH, 0A5H
.equ    CANGSTA, 0AAH
.equ    CANGCON, 0ABH
.equ    CANTIML, 0ACH
.equ    CANTIMH, 0ADH
.equ    CANSTMPL, 0AEH
.equ    CANSTMPH, 0AFH
.equ    CANPAGE, 0B1H
.equ    CANSTCH, 0B2H
.equ    CANCONCH, 0B3H
.equ    CANBT1, 0B4H
.equ    CANBT2, 0B5H
.equ    CANBT3, 0B6H
.equ    CANSIT1, 0BAH
.equ    CANSIT2, 0BBH
.equ    CANIDT1, 0BCH
.equ    CANIDT2, 0BDH
.equ    CANIDT3, 0BEH
.equ    CANIDT4, 0BFH
.equ    CANGIE, 0C1H
.equ    CANIE1, 0C2H
.equ    CANIE2, 0C3H
.equ    CANIDM1, 0C4H
.equ    CANIDM2, 0C5H
.equ    CANIDM3, 0C6H
.equ    CANIDM4, 0C7H
.equ    CANEN1, 0CEH
.equ    CANEN2, 0CFH

;---------------------------------------------------------
; End of file: t89c51cc01.i51
;---------------------------------------------------------
; --------------------------------------------------------------------------
; FILE: loopids.i51 - Tight-loop Identification Values - WD Expire Diag Sprt
; Copyright (C) 2002 by Stephen Moraco, KC0FTQ
; $Id: loopcodes.i51,v 1.2 2004/09/22 04:07:22 stephen Exp $
; --------------------------------------------------------------------------
; Include file for Tight-loop IDs
; --------------------------------------------------------------------------
;
;  THEORY OF OPERATION:
;   There are a small number of places where the firmware enters
;   tight loops where, if all is working, the loops will end without
;   incident.
;
;   As these loops are entered one of these codes is written to the
;   "I'm in a loop" variable.  As the loop is exited the variable is
;   cleared. (reset to LPID_NO_LOOP)
;
;   Should we hit a hardware watch-dog event we may be likely able to
;   identify where we were in the code which caused us to not service the
;   hardware watchdog preventing its expiration.  The theory is that we
;   might be in one of these tight loops
;
;   A possible advance is to record the codes in a list in more permanent
;   memory at each WD Expiration.  Some time later we'll be able to download
;   these codes in order to understand the event history of a particular
;   device.
;
;   The loop-id receiving variable is: diag_loopid (see memory.a51)
;
;   This diag_ variable tracks real hardware loops. These loops are protected
;   by the hardware-watchdog and are artifacts of having to synchronize with
;   real hardware which, in the worst case, can stop functioning.
;
;  (The LPID prefix stands for LOOP IDENTIFIER)

; -- Normal value when we are not in a tight loop
.equ  LPID_NO_LOOP,  0x00   ; NO-LOOP not currently in a loop

; -- Loops in CAN subsystem
.equ  LPID_TX1CMPLT, 0x13   ; CAN hung waiting for packet transmit to complete
.equ  LPID_CANENA,   0x1C   ; CAN hung waiting for device to come ready

; -- Loops in EEPROM access routines
.equ  LPID_EEBUSY,   0x25   ; EEPROM hung at busy
.equ  LPID_EEWRTDON, 0x2A   ; EEPROM hung waiting for write to complete

; --------------------------------------------------------------------------
;                       End of file: loopids.i51
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Global Data
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: memory.a51,v 1.56 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
;
;  our available resources
;
;  - Special Function Registers (SFR's)
;   -- User Flag bits (BIT ADDRESSABLE)
;    PSW:F0 - controls leading zero supression on decimal displays
;    PSW:F1 - copy of EA bit when in "atomic" routines
;
;   --NOT BIT ADDRESSABLE (read reg and mask or set)--
;    PCON:GF0   - IDLE-MODE indication: 1=in IDLE, 0=Not IDLE (checked in ISR)
;    PCON:GF1   -
;    AUXR1:GF3  -
;
;   -- User registers
;    DPTR0 (AUXR1:DPS=0) normal code use
;    DPTR1 (AUXR1:DPS=1) special (within subroutine use)
;
;  - internal RAM
;   -- 4 banks of registers [0-1f]
;     --- Bank 0: R0-R7  - default system use (CAN in byte pipe mode)
;     --- Bank 1: R0-R7  -   unallocated
;     --- Bank 2: R0-R7  -   unallocated
;     --- Bank 3: R0-R7  - used by byte-pipe mode

;  our PSW register bank selection equates
.equ  BITS_REG_BNK0, 0x00
.equ  BITS_REG_BNK1, 0x08
.equ  BITS_REG_BNK2, 0x10
.equ  BITS_REG_BNK3, 0x18
.equ  MASK_REG_BNKS, 0xFF - BITS_REG_BNK3
; accellerations:
;   AND to set reg bank 0
.equ SEL_BNK0, MASK_REG_BNKS
;      anl   psw,#SEL_BNK0
;    OR to set reg bank 3
.equ SEL_BNK3, BITS_REG_BNK3
;      orl   psw,#SEL_BNK3

;   AND to select DPTR0
.equ DPS, 0x01
.equ SEL_DPTR0, 0xff-DPS
;    OR to select DPTR1
.equ SEL_DPTR1, DPS

; -----------------------------------------------------------
;   -- bit addressable [20-2f(byte addr.), 00-7f(bit addr.)]
; -----------------------------------------------------------
.equ    ram_bits_start, 0x20    ; first byte of direct bit-addressable ram

;*** --------------------------------------------------------
; storage for our most recent output bit def's (copy 1 of 2)
;  this is lowest addressed copy
.equ    FLGBYT20, 0x20
.equ    outs1_cpy, FLGBYT20     ; base of this 2or8-byte configure copy1of2
.equ    outs1_cpy0, FLGBYT20
.equ    FLGBYT21, 0x21
.equ    outs1_cpy1, FLGBYT21
.equ    FLGBYT22, 0x22
.equ    outs1_cpy2, FLGBYT22
.equ    pipeout_payload, outs1_cpy2 ; outgoing payload[0-7]-build
.equ    FLGBYT23, 0x23
.equ    outs1_cpy3, FLGBYT23
.equ    FLGBYT24, 0x24
.equ    outs1_cpy4, FLGBYT24
.equ    FLGBYT25, 0x25
.equ    outs1_cpy5, FLGBYT25
.equ    FLGBYT26, 0x26
.equ    outs1_cpy6, FLGBYT26
.equ    FLGBYT27, 0x27
.equ    outs1_cpy7, FLGBYT27
; and overlay incoming copy _s1 with special names
.equ    outbits70,  outs1_cpy0  ; Module OUT7..0
.equ    outbits118, outs1_cpy1  ; Module OUT11..8 (Pxxxbbbb)       std-mode (.7=pwr)
.equ    outbits98, outs1_cpy1   ; Module OUT9..8  (Pxxxxxbb) byte-pipe-mode (.7=pwr)
.equ    outbits5662, outs1_cpy7 ; Module OUT11..8 (Pbbbbbbb)       mux-mode (.7=pwr)
;*** --------------------------------------------------------

; following two bytes overlapped by pipeout_payload (6,7 :of 0-7)
.equ    FLGBYT28, 0x28
.equ    FLGBYT29, 0x29
; following is 1st free flag-byte if byte-pipe mode
.equ    FLGBYT2A, 0x2A

.equ    FLGBYT2B, 0x2B
.flag   PWRCTLVAL, FLGBYT2B.7       ; mirror of our power-control output
.flag   INCANISR, FLGBYT2B.6        ; control CAN routine based on caller
.flag   ISWDSTART, FLGBYT2B.5       ; T/F where T means we started from WD expiration

.equ    FLGBYT2C, 0x2C
.equ    CANWTG, FLGBYT2C    ; CAN: need msg bits, when 0, done
.flag   OBJ0, CANWTG.0
.flag   OBJ1, CANWTG.1
.flag   OBJ2, CANWTG.2
.flag   OBJ3, CANWTG.3
.flag   OBJ4, CANWTG.4
.flag   OBJ5, CANWTG.5
.flag   OBJ6, CANWTG.6
.flag   OBJ7, CANWTG.7

.equ    FLGBYT2D, 0x2D  ; CAN Widget State
.flag   CANXMTIDLE, FLGBYT2D.7 ; set @sysinit, cleared/set wrapping each CAN-xmit: canio.a51
.flag   SHODEBUG, FLGBYT2D.6    ; 1=sho debug messages, 0=don't sho debug
.flag   BOOT_OK, FLGBYT2D.5 ; 1=cksum matched, 0=cksum didn't match
.flag   ERAM_OK, FLGBYT2D.4 ; 1=cksum matched, 0=cksum didn't match
.flag   BADCANRX, FLGBYT2D.3    ; 1=flawed packets rx'd, 0=pkt rx'd OK
.flag   MUX_MODE, FLGBYT2D.1        ; single bit interp of MUX mode for code simplicity
.flag   PIPE_MODE, FLGBYT2D.0   ; single bit interp of BYTE-PIPE mode for code simplicity

.equ    FLGBYT2E, 0x2E  ; INPUT-Bits DECODE
.equ    INBITS, 0x2E

.equ    FLGBYT2F, 0x2F  ; CAN Widget state
.flag   PIPEWASBUSY, FLGBYT2F.7     ; 1=reset while active, 0=was not
.flag   PIPEINBUSY, FLGBYT2F.6      ; 1=IN Xaction InProgress, 0=not yet
.flag   PIPEOUTBUSY, FLGBYT2F.5     ; 1=OUT Xaction InProgress, 0=not yet
.flag   PIPENEWMSG, FLGBYT2F.4      ; 1=CAN Msg arrived with content to send via pipe, 0=not
.flag   PIPEABORT, FLGBYT2F.3       ; 1=abort pipe effort, 0=not yet
.flag   PIPEINEXP, FLGBYT2F.2       ; 1=IN timer expired, 0=not yet
.flag   PIPEOUTEXP, FLGBYT2F.1      ; 1=OUT timer expired, 0=not yet

; -----------------------------------------------------------
;   -- direct/indirect accesable [30-7f]
; -----------------------------------------------------------
;
.equ    ram_start, 0x30             ; first byte of direct ram
; calculations...
.equ    ram_mid, ram_bits_start + 48 - 6    ; middle byte of direct ram
.equ    ram_top, ram_start + 80 - 1 ; last byte of direct ram
.equ    ram_lenwbits, ram_top - ram_bits_start + 1

;*** SIGNATURE *************************;
.equ    ramsig1, ram_start              ; RAM signature 1of4 for reset use
.equ    ramsig2, ramsig1+1              ; RAM signature 2of4 for reset use
;*** SIGNATURE *************************;

; storage for our analog to digital conversion results (12-bit) by channel
; each channel loc'n is a word, msBits stored in byte+0, lsBits in byte+1
;     (RAM[loc+0]=[00000098], RAM[loc+1]=[76543210])
.equ    adc_chan_base, ramsig2+1
.equ    adc_chan0, adc_chan_base+0
.equ    adc_chan1, adc_chan_base+2
.equ    adc_chan2, adc_chan_base+4
.equ    adc_chan3, adc_chan_base+6
.equ    adc_chan4, adc_chan_base+8
.equ    adc_chan5, adc_chan_base+10
.equ    adc_chan6, adc_chan_base+12
.equ    adc_chan7, adc_chan_base+14

.equ    next_chan, adc_chan7+2  ; ADC channel idx (used during conversion loop)

.equ    pipein_idx, next_chan+1     ; index to next in byte (post incr)
.equ    pipeout_idx, pipein_idx+1   ; index to next out byte (post incr)

.equ    mod_addr, pipeout_idx+1 ; CAN SR address bits
.equ    mod_mode, mod_addr+1    ; CAN SR mode bits (>> 6)
; values for mod_mode field
.equ    MODE_STD, 0x03          ;-Standard Mode
.equ    MODE_MUX, 0x02          ;-Multiplexed Mode
.equ    MODE_PIPE, 0x01         ;-Byte-pipe Mode
.equ    mod_bits, mod_mode+1    ; CAN Raw value read from SR
.equ    endaddr_msb, mod_bits+1 ; store end address (for loops)

;*** --------------------------------------------------------
; storage for our mid-most output bit def's (copy 2 of 2)
.equ    outs2_cpy, endaddr_msb+1    ; base of this 2or8-byte configure copy2of2
.equ    outs2_cpy0, outs2_cpy
.equ    outs2_cpy1, outs2_cpy+1
.equ    outs2_cpy2, outs2_cpy+2
.equ    pipein_payload, outs2_cpy2  ; incoming payload[0-7]-build
.equ    outs2_cpy3, outs2_cpy+3
.equ    outs2_cpy4, outs2_cpy+4
.equ    outs2_cpy5, outs2_cpy+5
.equ    outs2_cpy6, outs2_cpy+6
.equ    outs2_cpy7, outs2_cpy+7
;*** --------------------------------------------------------

.equ    payload_base, pipein_payload + 8
.equ    payload0, payload_base+0    ; CAN misc message buffer[0]
.equ    payload1, payload_base+1    ; CAN misc message buffer[1]
.equ    payload2, payload_base+2    ; CAN misc message buffer[2]
.equ    payload3, payload_base+3    ; CAN misc message buffer[3]
.equ    payload4, payload_base+4    ; CAN misc message buffer[4]
.equ    payload5, payload_base+5    ; CAN misc message buffer[5]
.equ    payload6, payload_base+6    ; CAN misc message buffer[6]
.equ    payload7, payload_base+7    ; CAN misc message buffer[7]

;  RAM SPACES for check-sum storage
.equ    cksum_base,      payload7+1
.equ    ram_cksum,       cksum_base+0 ; SUMH, SUML  - 16bit sum
.equ    flash_cksum,     cksum_base+2 ; SUMH, SUML  - 16bit sum
.equ    eeprom_cksum,    cksum_base+4 ; SUMH, SUML  - 16bit sum
.equ    bootflash_cksum, cksum_base+6 ; SUMH, SUML  - 16bit sum (1b signals OK)
.equ    eram_cksum,      cksum_base+8 ; SUMH, SUML  - 16bit sum (1b signals OK)
.equ    last_cksum,      eram_cksum       ; mark last checksum word

;  RAM diagnostic tracking of tight-loops
.equ    diag_loopid,    last_cksum+2  ; BYTE containing an LPID_ value

;  RAM counters of bad events
.equ    ctr_base,       diag_loopid+1
.equ    ctr_wrong_pkt,  ctr_base+0  ; ERR counter (CANSTCH:DLCW b7)
.equ    ctr_can_berr,   ctr_base+1  ; ERR counter (CANSTCH:BERR b4)
.equ    ctr_can_serr,   ctr_base+2  ; ERR counter (CANSTCH:SERR b3)
.equ    ctr_can_cerr,   ctr_base+3  ; ERR counter (CANSTCH:CERR b2)
.equ    ctr_can_ferr,   ctr_base+4  ; ERR counter (CANSTCH:FERR b1)
.equ    ctr_can_aerr,   ctr_base+5  ; ERR counter (CANSTCH:AERR b0)
.equ    ctr_can_boff,   ctr_base+6  ; ERR counter (CANGSTA:BOFF b1)
.equ    ctr_can_errp,   ctr_base+7  ; ERR counter (CANGSTA:ERRP b0)
.equ    ctr_wd_resets,  ctr_base+8  ; ERR counter simulated (ct events)
.equ    last_ctr,       ctr_wd_resets       ; mark last counter

.equ    ctr_bytes,  last_ctr - ctr_base + 1 ; number of counter bytes to clear
.equ    pipe_ctrs_base,   last_ctr+1
.equ    ctr_pipein_tmot,  pipe_ctrs_base+0  ; ERR counter (pipe-input S/W W/D Expired)
.equ    ctr_pipeout_tmot, pipe_ctrs_base+1  ; ERR counter (pipe-output S/W W/D Expired)
.equ    ctr_pipebad_canrx, pipe_ctrs_base+2 ; ERR counter (pipe-output S/W W/D Expired)
.equ    last_pipe_ctr,    ctr_pipebad_canrx
.equ    ram_1stfree, last_pipe_ctr+1

; calc offset for our top most output bits copy, pipe bffr, and signature
.equ    ram_top_sig, ram_top-2      ; (7+4 extra: pipe-mode overlap at end)

;*** SIGNATURE *************************;
.equ    ramsig3, ram_top_sig            ; RAM signature 3of4 for reset use
.equ    ramsig4, ramsig3+1              ; RAM signature 4of4 for reset use
;*** SIGNATURE *************************;

; free-space and size info
.equ    ram_free, ram_top_sig - ram_1stfree
.equ    ram_len, ram_top - ram_start + 1

; -----------------------------------------------------------
;   -- indirect (only) addressable [80-ff]
; -----------------------------------------------------------
;     --- stack space is here and grows towards higher addrs
.equ    stack_base, 0x82

;
; -----------------------------------------------------------
;   -- Our code offsets
; -----------------------------------------------------------
;
; Addressing within instructions is aware of 2K boundaries!
;
;   lcall  ljmp  16bit addr (tgt instr: anywhere in 16bit addr space)
;   acall  ajmp  11bit addr (tgt instr: same 2K page,addr following curr instr)
;   -----  sjmp  -128/+127  (2's comple offset added to PC)
;
; For us to code correctly, we must be too. These equates define these
; locations for us.  We then place code within specific pages by
; using .org directives with the code_pageN values. These leave
; 32 pages in the 64K space. (since we only have 32K flash we
; have 16 pages numbered 0-15.)
;
.equ    code_page0,          0x0000 ; CODE page [0000-07ff]
.equ    code_page1, code_page0+2048 ; CODE page [0800-0fff]
.equ    code_page2, code_page1+2048 ; CODE page [1000-17ff]
.equ    code_page3, code_page2+2048 ; CODE page [1800-1fff]
.equ    code_page4, code_page3+2048 ; CODE page [2000-27ff]
.equ    code_page5, code_page4+2048 ; CODE page [2800-2fff]
.equ    code_page6, code_page5+2048 ; CODE page [3000-37ff]
.equ    code_page7, code_page6+2048 ; CODE page [3800-3fff]
.equ    code_page8, code_page7+2048 ; CODE page [4000-47ff]
.equ    code_page9, code_page8+2048 ; CODE page [4800-4fff]
.equ    code_pageA, code_page9+2048 ; CODE page [5000-57ff]
.equ    code_pageB, code_pageA+2048 ; CODE page [5800-5fff]
.equ    code_pageC, code_pageB+2048 ; CODE page [6000-67ff]
.equ    code_pageD, code_pageC+2048 ; CODE page [6800-6fff]
.equ    code_pageE, code_pageD+2048 ; CODE page [7000-77ff]
.equ    code_pageF, code_pageE+2048 ; CODE page [7800-7fff]
.equ    rom_top, code_pageF + 2048 - 1 ; last byte of ROM

; -----------------------------------------------------------
;  Offsets for debug strings (via serial I/O)
.equ    checksums_strings, code_page4+0
.equ    main_strings, checksums_strings+256
.equ    canio_strings, main_strings+256
;
;  End of Global Data
; -----------------------------------------------------------
; -------------------------------------------------------------------------
; AMSAT Module CAN Interface
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: modinit.a51,v 1.122 2004/09/29 07:49:31 stephen Exp $
; -------------------------------------------------------------------------
;
.equ    psw_init, 0         ;value for psw (which reg bank to use)
.equ    stack, stack_base   ;location of the stack

    .org    code_page0
reset:
    ljmp    poweron     ;reset vector

; -------------------------------------------------------------------------
;   Interrupt Vectors
; -------------------------------------------------------------------------
extint0:        ; P01 External Interrupt 0 (INT0)
    sjmp    intr_return
    .skip 6
timer0:         ; P02 Timer 0 (TF0)
    sjmp    intr_return
    .skip 6
extint1:        ; P03 External Interrupt 1 (INT1)
    sjmp    intr_return
    .skip 6
timer1:         ; P04 Timer 1 (TF1)
    sjmp    intr_return
    .skip 6
uart:           ; P06 Serial UART (RI or TI)
    sjmp    intr_return
    .skip 6
timer2:         ; P07 Timer 2 (TF2)
    sjmp    intr_return
    .skip 6
pca:            ; P05 PCA (CF or CCFn)
    sjmp    pca_handler
    .skip 6
can:            ; P08 CAN (TxOK, RxOK, Err, or OverBuf)
    sjmp    can_handler
    .skip 6
adc:            ; P09 ADC (ADCI)
    clr     OUT1        ; (tst) strobe: digitize ISR fired
    setb    OUT1
    sjmp    adc_handler ; only have 6bytes, some code not in vector space
    .skip 2
canover:        ; P10 CAN Timer Overflow (OVRTIM)
    nop
    ; nothing here for now...
intr_return:
    reti
adc_handler:
    anl     ADCON,#0xff-0x10    ; clear interrupt
    sjmp    intr_return ; exit from ISR

; =========================================================================
;            CAN   Interrupt Service Routine
; -------------------------------------------------------------------------
can_handler:
    setb    INCANISR        ; we are now running in ISR
    push    acc             ; preserve A
    mov     a,CANPAGE
    push    acc             ; preserve CANPAGE
    push    psw             ; preserve REGISTER SET in use
    clr     OUT2        ; (tst) strobe: CAN ISR fired
    setb    OUT2
    anl     psw,#SEL_BNK0   ; select to our main regs
    mov     a,CANSIT2       ; message OBJ 0-7 interrupting?
    jnz     yesCANint       ; yes- go handle it
    mov     a,CANSIT1       ; message OBJ 8-14 interrupting?
    jz      noOthMsgs       ; no- on to next check
    mov     CANSIT1,#0      ; TEMP clear these if need to be
noOthMsgs:
    mov     a,CANGIT        ; CAN message error?
    anl     a,#0x9f         ; kill timer bit and reserved bit
    jz      noCANint        ; no- go exit this ISR
    mov     CANGIT,#0       ; TEMP clear these too...
noCANint:
    pop     psw             ; restore REGISTER SET in use
    pop     acc             ; restore A
    mov     CANPAGE,a       ; restore CANPAGE
    pop     acc
    clr     INCANISR        ; we are NO LONGER running in ISR
    sjmp    intr_return     ; exit INT handler

yesCANint:
    acall   hndl_CANmsg     ; process CAN MSG-OBJ[0-7] interrupt
    sjmp    noCANint        ; exit INT handler after restoring A

; =========================================================================
;            PCA   Interrupt Service Routine
; -------------------------------------------------------------------------
pca_handler:
    jb      CCF0,hndlINexp      ; if Pipe-in Timer expired, go
    jb      CCF1,hndlOUTexp     ; if Pipe-out Timer expired, go
notPipeTimer:
    ; oops, mis-code? not one of our timers...
    sjmp    intr_return ; exit from ISR

hndlOUTexp:
    lcall   disa_pipeout        ; prevent any more interrupts
    inc     ctr_pipeout_tmot    ; count this transaction failure
    setb    PIPEOUTEXP          ; this is the timer that expired
    sjmp    hndlExpEnd  ; go finish up handling this
hndlINexp:
    lcall   disa_pipein         ; prevent any more interrupts
    inc     ctr_pipein_tmot     ; count this transaction failure
    setb    PIPEINEXP           ; this is the timer that expired
hndlExpEnd:
    setb    PIPEABORT           ; mark that a pipe timer expired!
    sjmp    intr_return ; exit from ISR

sw_ver:
; 00.01       first working CAN
; 00.02       working
; 00.03,00.04 first with split dbg/non-dbg, 1st working jmp2isp/getctrs
; 00.05,00.06 first with working mux mode (off of mode bits, of course)
; 00.07,00.08 first with byte-pipe mode ready for testing
; 00.09,00.10 2nd ver byte-pipe (test code), all bits inverted,
;             ignore bad cfg pkts, Module Power is now OFF on startup
; 00.11,00.12 3rd ver byte-pipe (1st full function, full speed)
; 00.13,00.14 3rd ver ADC/16 Prescale at 6
;  --skip 00.15--  (from now on ls-bit indicates SIO-and/or-STROBES enabled)
; 01.00,01.01 Awakened H/W WD behaviors!
; 01.02,01.03 4th ver ADC algorithm, pipe-timer startup, dual mux pass
.equ    base_ver, 0x12  ; [[[INCREMENT by TWO only!!!]]]
.byte   base_ver+1  ; our software version(ODD): w/SIO,STROBES

; -------------------------------------------------------------------------
;   Power-On initialization code and such...
; -------------------------------------------------------------------------

;first the hardware has to get initialized.

poweron:
    clr     a           ; get all zeros
    mov     ien0, a     ; all interrupts off
    mov     ien1, a
    mov     ipl0, a     ; reset interrupt priorities
    mov     ipl1, a     ;  (all to lowest)
    mov     iph0, a
    mov     iph1, a
    mov     psw, #psw_init  ; activate register bank zero

    ;clear any interrupt status, just in case the user put
    ;"ljmp 0" inside their interrupt service code.
    acall   intr_return
    acall   intr_return

    cpl     a           ; get all ones
    mov     p0, a       ; set all ports to high-impedence
    mov     p1, a
    mov     p2, a
    mov     p3, a
    mov     sp, #stack  ; setup our stack pointer

; init our RAM locations
    lcall   init_ram    ; init RAM areas  (if 1st power up, zero flags, etc.)

    setb    c           ; set the carry bit (set POWER OFF)
    mov     PWRCTLVAL,c ; set our in-RAM power control bit image
    mov     PWRCTRL,c   ; set our output power control line
; mark that we just powered on and/or reset!
    clr     OUT0        ; (tst) 0 strobe to mark RESET happened
    setb    OUT0

; We flash the X2B bit (Hardware Byte) so the uP is running at X2 from
; reset!!
    mov     CKCON,#0x41     ; enable X2 mode bits by device, too

; init onboard devices/subsystems
    lcall   init_sr     ; stabilize the Address/mode shift register (SR)
    ; NOW init things which need to know mode...
    lcall   load_config ; read jumper settings (addr/mode) fm SR, store to RAM
    ; if NOT hardware watchdog reset go do cold-start
    jnb     ISWDSTART, cold_start
warm_start:
    ; ---------------------------------------------------------------------
    ;   restore last config bits to digital outputs IFF WD-induced restart
    ; ---------------------------------------------------------------------
    lcall   reload_config   ; restore last configure value to output ports (incl. pwr setting)
    ; ---------------------------------------------------------------------
cold_start:
    lcall   init_adc    ; setup our 8-channel ADC
    lcall   init_can    ; setup CAN device
    ; TST iff can-boot requested, doit instead of setting up WD
    lcall   isbootrqst  ; TST is WD fire after jump2ISP can msg?
    jnc     dowdinit    ; TST no, then carry on with inits
    ljmp    canboot     ; TST yes, go jump into CAN boot loader...
dowdinit:
    lcall   init_wd     ; start our H/W watchdog timer (awaken after memory copies created!)
    ; NOT using serial I/O quiesce the hardware...
    acall   init_sio    ; setup our serial I/O using Timer2 for BRgen

    ; setup our CAN device (listening objects for this mode)
    acall   init_cenrqst    ; enable listening for Census query broadcasts
    acall   init_isprqst    ; enable listening for reprogramming rqst broadcasts
    acall   init_tstrqst    ; enable listening for TEST messages
    lcall   init_ctrsrqst   ; enable listening for get-ctrs messages addr'd to me
    lcall   init_cfgrqst    ; enable listening for configure messages addr'd to me

    lcall   sum_memory  ; calculate checksums of all areas
    lcall   chk_sums    ; set bits for 2 of 5 checksums
    clr     OUT0        ; (tst) strobe: end of init's, entering main loop
    setb    OUT0
    clr     OUT0
    setb    OUT0

; *************************************************************************
; **  Runtime Resource Allocation
; **
; **  All Modes:
; **    ACC   - >>> transient <<<
; **    DPTR  - >>> not used <<<
; **  (Register bank 0)
; **    R7,R6 - CANIDT2,CANIDT1 CAN Macro Registers
; **    R5    - Stream [0-F]
; **    R4    - Device Address [00-3F]
; **    R3    - Payload Length in bytes [0-8]
; **    R2    - (buffer pointer for CAN unload (save to RAM))
; **    R1    - >>> transient <<<
; **    R0    - >>> transient <<<
; **  Byte-pipe Mode (Additional resources)
; **  (Register bank 3)
; **   IN (Module to Widget)
; **    R0   -  IN address of next location in RAM to be written
; **   OUT (Widget to Module)
; **    R1   - OUT address of next location in RAM to be read
; **
; *************************************************************************
; **  DISPATCH to appropriate MAIN LOOP (std/mux -or- pipe)
    jb      PIPE_MODE,pipe_main
    ; fall THRU to standard mode or Mux mode loop

; *************************************************************************
; **  Main loop (Standard, Multiplex Mode):
; **   Do forever:
; **    - Enable CAN & Overall Interrupts
; **    - Mark that we are IDLE
; **    - Switch into IDLE mode (halt CPU wtg for interrupt)
; **    - Mark that we are awake
; **   End-Do
; *************************************************************************
std_main:

; defines for bits within non-bit-addressable PCON register
.equ    GF1,0x08
.equ    GF0,0x04
.equ    IDL,0x01

; eeee -> TODO have not yet awakened detect (in ISR) of GF0 being set

    ; enable interrupts for CAN message handling
    setb    ECAN            ; enable interrupts from CAN  device
    setb    EA              ; enable interrupt system
    ; show entering IDLE
    orl     PCON,#GF0       ; set IN-IDLE state
    orl     PCON,#IDL       ; enter IDLE power state
    ; leaving IDLE
    nop
    ; show left IDLE
    anl     PCON,#0xff-GF0  ; set NOT-IN-IDLE state
    ; loop again, ensuring the CAN ISR is enabled
    sjmp        std_main    ; loop...

; *************************************************************************
; **  Main loop (Pipe Mode):
; **   Do forever:
; **    - Handle any Received Message
; **    - (STATE MACHINE) Poll for Byte-pipe I/O, Timeout, CAN Pipe OUT Rx
; **    - Handle CAN Error
; **   End-Do
; *************************************************************************
pipe_main:
    ; Init the byte pipe mech.
    lcall   init_piperqst   ; enable listening for Byte-pipe wr msgs addr to me
    lcall   init_pipeWDs    ; configure pipe software-watchdog mechanism
    setb    INACK           ; force pipe input-ack to !ACK
    setb    OUTREQ          ; force pipe output-req to !REQ
    clr     PIPEABORT       ; clear our timer expiration/shutdown notice
    clr     PIPENEWMSG      ; clear indication of arrived pipe-write packets
    ; Enable interrupts for CAN message handling
    setb    ECAN            ; enable interrupts from CAN  device
    setb    EA              ; enable interrupt system

; *************************************************************************
; **   STATE: NoPower   (POWER-UP/RESET ENTRY STATE)
; *************************************************************************
; now we'll hang here until a configure CAN msg (via interupt) enables power
;
;  NOTE: a 'clr     INACK'  has been done by the configure packet handler
;        just before the Module Power was turned on...  by the time
;        we get thru this loop the INACK is asserted and now needs to be
;        de-asserted when the stabilization-delay loop finishes
NoPower:
    jb      PWRCTLVAL,NoPower   ; loop til power is applied, then fall thru
    ; fall THRU to power-up delay state

; *************************************************************************
; **   STATE: PwrUpDelay   (Module just powered-on STATE)
; *************************************************************************
; now we'll hang here until we've waited long enough that Module interface
;  circuitry has stabilized
PwrUpDelay:
    ; set up the number of 2mSec wait loops we need
    mov     r2,#2   ; wait 2 x 2 mSec (4 mSec total)
nxDlyLp:
    ; start one of our 2mSec timers
    lcall   ena_pipeout ; start our pipe-out timer (pipe-in woulda worked too)
wtTmrExpLp:
    jnb     PIPEOUTEXP,wtTmrExpLp   ; if timer not expired, continue wtg
    dec     ctr_pipeout_tmot        ; un-count this expiration (not real)
    clr     PIPEABORT               ; clear timer-expire-induced abort (not real)
    djnz    r2,nxDlyLp              ; if we more iterations to do, go back, do another
    setb    INACK   ; inform module we are ready for service
    ajmp    InB     ; go 1st STATE

; *************************************************************************
; **   STATE: InBeginOutBegin
; *************************************************************************
InBotB_cknoACK:
    jnb     OUTACK,InBotB_nopipe    ; if still asserted from last byte...
    ; previous byte fully handshaked, ready to send next!
    mov     a,@r1                   ; get byte
    mov     DATAOUT,a               ; write outgoing BYTE
    clr     OUTREQ                  ; assert our OUTput REQuest signal
    inc     r1                      ; point to next outgoing byte
    cjne    r1,#pipeout_payload+1,InBotE_ckREQ  ; jump, if not 1st byte, to NEXT STATE
    lcall   ena_pipeout             ; go start pipe-out 8-byte timer
    sjmp    InBotE      ; and on to NEXT STATE

InBotB_nopipe:
    jnb     PIPEABORT,InBotB_ckREQ  ; if abort NOT requested, loop...
    clr     PIPEABORT               ; Abort requested, we're handling it
    jb      PIPEOUTEXP,InB_noInInit ; if OUT timer exp., abandon out, cont. IN
    jb      PIPEINEXP,InBotB_inExp  ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr  ; lost module power, go...
    sjmp    InB     ; we've been asked to do unconditional reset, start over

InBotB:
    ; INIT pipe-in, pipe-out
    mov     r1,#pipeout_payload
    clr     PIPENEWMSG              ; we've processed this message
InBotB_rstIN:
    mov     r0,#pipein_payload
InBotB_ckREQ:
    jb      INREQ,InBotB_cknoACK    ; if NOT asserted...
    ; Sender is handing us a byte, get the byte and ACK it
    mov     a,DATAIN                ; get incoming BYTE
    clr     INACK                   ; assert our INPUT-ACK signal
    mov     DATAOUT,a               ; TST echo as outgoing BYTE TST
    mov     @r0,a                   ; write value to our payload area
    inc     r0                      ; point to next location
    cjne    r0,#pipein_payload+1,InBotB_goInEotB    ; jump if not 1st byte to NEXT STATE
    lcall   ena_pipein              ; go start pipe-in 8-byte timer
InBotB_goInEotB:
    ajmp    InEotB  ; and on to NEXT STATE

; *************************************************************************
; **   STATE: InBeginOutEnd
; *************************************************************************
InBotE_ckACK:
    jb      OUTACK,InBotE_nopipe    ; if asserted...
    ; OUTACK is asserted, we can remove our REQ now...
    setb    OUTREQ                  ; de-assert our OUTput REQuest
    ; WARNING if r1 gets >8 we've got trouble...
    cjne    r1,#pipeout_payload+8,InBotB_ckREQ  ; if not sent all, go send next
    lcall   disa_pipeout            ; Cancel our Pipe-outTimer
    ; eeee -> TODO???? reset CAN receive object (allow another to be received)
    sjmp    InB     ; done with this output packet, go handle input only...

InBotE_nopipe:
    jnb     PIPEABORT,InBotE_ckREQ  ; if abort NOT requested, loop...
    clr     PIPEABORT               ; Abort requested, we're handling it
    jb      PIPEOUTEXP,InB_noInInit ; if OUT timer exp., abandon out, cont. IN
    jb      PIPEINEXP,InBotE_inExp  ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr  ; lost module power, go...
    sjmp    InB     ; we've been asked to do unconditional reset, start over

InBotE:
InBotE_rstIN:
    ; INIT pipe-in
    mov     r0,#pipein_payload
InBotE_ckREQ:
    jb      INREQ,InBotE_ckACK      ; if NOT asserted...
    ; Sender is handing us a byte, get the byte and ACK it
    mov     a,DATAIN                ; get incoming BYTE
    clr     INACK                   ; assert our INPUT-ACK signal
    mov     DATAOUT,a               ; TST echo as outgoing BYTE TST
    mov     @r0,a                   ; write value to our payload area
    inc     r0                      ; point to next location
    cjne    r0,#pipein_payload+1,InBotE_goInEotE    ; jump if not 1st byte to NEXT STATE
    lcall   ena_pipein  ; go start pipe-in 8-byte timer
InBotE_goInEotE:
    ajmp    InEotE  ; and on to NEXT STATE

; *************************************************************************
; **   STATE: InBegin   (ENTRY STATE, IFF Module power is on)
; *************************************************************************
InB_nopipe:
    jb      PIPENEWMSG,InBotB       ; have OUTPUT bytes, go to NEXT STATE to start sending
    jnb     PIPEABORT,InB_ckREQ ; if abort NOT requested, loop...
    clr     PIPEABORT               ; Abort requested, we're handling it
    jb      PIPEINEXP,InB_inExp     ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr  ; lost module power, go...
    sjmp    InB     ; we've been asked to do unconditional reset, start over

InB:
    ; INIT pipe-in
    orl     psw,#SEL_BNK3           ; hey, they're in bank3
    mov     r0,#pipein_payload      ; point to payload receiving area
    clr     PIPEABORT               ; reset any indication of failure
InB_noInInit:
InB_ckREQ:
    jb      INREQ,InB_nopipe        ; if NOT asserted...
    ; Sender is handing us a byte, get the byte and ACK it
    mov     a,DATAIN                ; get incoming BYTE
    clr     INACK                   ; assert our INPUT-ACK signal
    mov     DATAOUT,a               ; TST echo as outgoing BYTE TST
    mov     @r0,a                   ; write value to our payload area
    inc     r0                      ; point to next location
    cjne    r0,#pipein_payload+1,InB_goInE  ; jump if not 1st byte to NEXT STATE
    lcall   ena_pipein              ; go start pipe-in 8-byte timer
InB_goInE:
    ajmp    InE     ; and on to NEXT STATE

; pipe-in Timer expired... clean up then off to restart this state
InBotB_inExp:
    ; expiration already recorded elsewhere...
    acall   snd_partial_read_pkt    ; go send partial packet, iff have bytes
    ; this is an IN expiration so go back but DON'T disturb OUT side
    ajmp    InBotB_rstIN        ; go start this all over again...

; pipe-in Timer expired... clean up then off to restart this state
InBotE_inExp:
    ; expiration already recorded elsewhere...
    acall   snd_partial_read_pkt    ; go send partial packet, iff have bytes
    ; this is an IN expiration so go back but DON'T disturb OUT side
    sjmp    InBotE_rstIN        ; go start this all over again...

; *************************************************************************
; Here when power is removed while in any state of state machine.
; Discover if either pipe was busy, record fact, then continue to no-power
; *************************************************************************
reenterNoPwr:
    ;
    ; (detect pipe busy and mark)
    mov     c,PIPEINBUSY
    orl     c,PIPEOUTBUSY
    mov     PIPEWASBUSY,c
    ajmp    NoPower ; no, enter power wait loop

; *************************************************************************
; **   STATE: InEndOutEnd
; *************************************************************************
InEotE:
InEotE_cknoREQ:
    jnb     INREQ,InEotE_ckACK      ; if still asserted...
    ; sender has seen our ACK so clear it readying for next byte
    setb    INACK                   ; de-assert our INPUT-ACK signal
    ; WARNING if r0 gets >8 we've got trouble...
    cjne    r0,#pipein_payload+8,InBotE_ckREQ   ; jump if not 8th byte to NEXT STATE
    ; ** here at end of byte 8...  we've completed our 8, do end processing
    lcall   disa_pipein             ; Cancel our Pipe-in Timer
    acall   snd_byte_read_pkt       ; have all eight, send them via CAN
    ajmp    InBotE      ; now back to wait for start of next in-packet

InEotE_ckACK:
    jb      OUTACK,InEotE_nopipe    ; if asserted...
    ; OUTACK is asserted, we can remove our REQ now...
    setb    OUTREQ                  ; de-assert our OUTput REQuest
    ; WARNING if r1 gets >8 we've got trouble...
    cjne    r1,#pipeout_payload+8,InEotB_cknoREQ    ; if not sent all, go send next
    lcall   disa_pipeout            ; Cancel our Pipe-out Timer
    ; eeee -> TODO???? reset CAN receive object (allow another to be received)
    sjmp    InE     ; done with this output packet, go handle input only...

InEotE_nopipe:
    jnb     PIPEABORT,InEotE_cknoREQ        ; if abort NOT requested, loop...
    clr     PIPEABORT               ; Abort requested, we're handling it
    jb      PIPEOUTEXP,InE_noInInit ; if OUT timer exp., abandon out, cont. IN
    jb      PIPEINEXP,InBotE_inExp  ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr  ; lost module power, go...
    ajmp    InB     ; we've been asked to do unconditional reset, start over

; pipe-in Timer expired... clean up then off to restart this state
InB_inExp:
    ; expiration already recorded elsewhere...
    acall   snd_partial_read_pkt    ; go send partial packet, iff have bytes
    ajmp    InB     ; go start this all over again...

; *************************************************************************
; **   STATE: InEndOutBegin
; *************************************************************************
InEotB:
    ; INIT pipe-out
    mov     r1,#pipeout_payload
    clr     PIPENEWMSG              ; we've processed this message
InEotB_cknoREQ:
    jnb     INREQ,InEotB_cknoACK    ; if still asserted...
    ; sender has seen our ACK so clear it readying for next byte
    setb    INACK                   ; de-assert our INPUT-ACK signal
    ; WARNING if r0 gets >8 we've got trouble...
    cjne    r0,#pipein_payload+8,InEotB_goInBotB_ckREQ  ; jump if not 8th byte to NEXT STATE
    ; ** here at end of byte 8...  we've completed our 8, do end processing
    lcall   disa_pipein             ; Cancel our Pipe-in Timer
    acall   snd_byte_read_pkt       ; have all eight, send them via CAN
    ajmp    InBotB      ; now back to wait for start of next in-packet
InEotB_goInBotB_ckREQ: ; this here 'cause code too big!
    ajmp    InBotB_ckREQ    ; go nget next byte

InEotB_cknoACK:
    jnb     OUTACK,InEotB_nopipe    ; if still asserted from last byte...
    ; previous byte fully handshaked, ready to send next!
    mov     a,@r1                   ; get byte
    mov     DATAOUT,a               ; write outgoing BYTE
    clr     OUTREQ                  ; assert our OUTput REQuest signal
    inc     r1                      ; point to next outgoing byte
    cjne    r1,#pipeout_payload+1,InEotE    ; jump if not 1st byte to NEXT STATE
    lcall   ena_pipeout             ; go start pipe-out 8-byte timer
    sjmp    InEotE  ; and on to NEXT STATE

InEotB_nopipe:
    jnb     PIPEABORT,InEotB_cknoREQ    ; if abort NOT requested, loop...
    clr     PIPEABORT                   ; Abort requested, we're handling it
    jb      PIPEOUTEXP,InE_noInInit     ; if OUT timer exp., abandon out, cont. IN
    jb      PIPEINEXP,InBotB_inExp      ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr      ; lost module power, go...
    ajmp    InB     ; we've been asked to do unconditional reset, start over

; *************************************************************************
; **   STATE: InEnd
; *************************************************************************
InE_nopipe:
    jb      PIPENEWMSG,InEotB       ; have OUTPUT bytes, go to NEXT STATE to start sending
    jnb     PIPEABORT,InE_cknoREQ   ; if abort NOT requested, loop...
    clr     PIPEABORT               ; Abort requested, we're handling it
    jb      PIPEINEXP,InB_inExp     ; IN timer expired, go...
    jb      PWRCTLVAL,reenterNoPwr  ; lost module power, go...
    ajmp    InB     ; we've been asked to do unconditional reset, start over

InE:
InE_noInInit:
InE_cknoREQ:
    jnb     INREQ,InE_nopipe        ; if still asserted...
    ; sender has removed request, lets, remove our ACK
    setb    INACK                   ; de-assert our INPUT-ACK
    ; WARNING if r0 gets >8 we've got trouble...
    cjne    r0,#pipein_payload+8,InE_goInB_ckREQ    ; jump if not yet processed all eight
    ; ** here at end of byte 8...  we've completed our 8, do end processing
    lcall   disa_pipein             ; Cancel our Pipe-in Timer
    acall   snd_byte_read_pkt       ; have all eight, send them via CAN
    ajmp    InB     ; now back to wait for start of next packet
InE_goInB_ckREQ: ; this here 'cause code too big!
    ajmp    InB_ckREQ

; --------------------------------------------------------------------------
;   BYTE-PIPE Mode: Module may have handed over 1-7 bytes,
;   if really have 1 or more, then send them via CAN
snd_partial_read_pkt:
    cjne    r0,#pipein_payload,hndl_partial_pkt
    ret ; return to caller (no received bytes)
hndl_partial_pkt:
    ; we've a byte or more to send, calculate actual length
    mov     a,r0                    ; get addr of what would have been next in byte
    clr     c                       ; clear this so no extra is subtracted
    subb    a,#pipein_payload       ; remove address component, leaving len
    mov     b,a                     ; place in reg than won't be bank switched
    sjmp    sbrp_have_len           ; now go send pkt of this length

; --------------------------------------------------------------------------
;   BYTE-PIPE Mode: Module handed over 8 bytes, now send them via CAN
snd_byte_read_pkt:
    mov     b,#8                    ; full payload is 8 bytes
sbrp_have_len:
    anl     psw,#SEL_BNK0           ; back to our main regs
    ;   r5 - stream/priority - [00-1f]
    ;   r4 - device addr - [00-3f]
    ;   r3 - payload len (payload assumed in payload0-payload7 (RAM))
    mov     r5,#RPL_BYTES           ; send to this stream
    mov     r4,mod_addr             ; set my address for broadcast
    mov     r3,b                    ; set payload length
    ; send CAN message with payload of our latest 8 bytes
    mov     r0,#pipein_payload
    lcall   page1xmpay              ; send CAN pkt but use our pipein-payload
    orl     psw,#SEL_BNK3           ; byte-pipe regs are in BANK3
sbrp_abort:
    ret     ; return to caller

; *************************************************************************
; **   End of STATE MACHINE IMPLEMENTATION
; *************************************************************************

; *************************************************************************
; **  Received Census Query Broadcast
; *************************************************************************
hndl_CANmsg:
try_cenrqst:    ; request received by object 0?
    jnb     acc.0,try_txok
    lcall   read_cenrqst ; capture message details
    jb      BADCANRX,badCenRqst ; if BAD packet bits/length, skip it
    ;  display our received address
    acall   rply_cenrqst    ; build and send our reply
badCenRqst:
    lcall   clr_cenrqst     ; re-enable listener
    ret     ; continue with main loop after rx handled

; *************************************************************************
; **  Received Transmit Complete
; *************************************************************************
try_txok:       ; request received by object 1?
    jnb     acc.1,try_tstrqst
    ; our TX completed (obj 1), ack it
    lcall   clr_txok        ; go clear the interrupt
    clr     OUT2        ; (tst) strobe: CAN xmit complete
    setb    OUT2
    clr     OUT2
    setb    OUT2
    ret     ; continue with main loop after rx handled
; *************************************************************************
; **  Received TEST message
; *************************************************************************
try_tstrqst:    ; request received by object 2?
    jnb     acc.2,try_cfgrqst
    lcall   read_tstrqst ; capture message details
    jb      BADCANRX,badTstRqst ; if BAD packet bits/length, skip it
    ;  display our received address
    acall   do_test             ; do test stuff
badTstRqst:
    lcall   clr_tstrqst     ; re-enable listener
    ret     ; continue with main loop after rx handled

; *************************************************************************
; **  Received Configure Widget message
; *************************************************************************
try_cfgrqst:    ; request received by object 3?
    jnb     acc.3,try_piperqst
    lcall   read_cfgrqst        ; capture reply address into r6,r7
    jnb     BADCANRX,hndlCfgRqst    ; if BAD packet bits/length, skip it
    ljmp    badCfgPktRx         ; configure packet is bad, skip it
hndlCfgRqst:
    jnb     MUX_MODE,tst_pipe_mode
    ajmp    hndl_mux_configure
tst_pipe_mode:
    jnb     PIPE_MODE,do_std_mode
    ajmp    hndl_pipe_configure
do_std_mode:
    ajmp    hndl_std_configure

; *************************************************************************
; **  Received Byte-pipe write Request
; *************************************************************************
try_piperqst:   ; request received by object 4?
    jnb     acc.4,try_ctrsrqst
    lcall   read_piperqst ; capture incoming msg
    jb      BADCANRX,badPipeRqst    ; if BAD packet bits/length, skip it
    ; iff module has power then notify of incoming message!
    ;   else count it as a bad message...
    jnb     PWRCTLVAL,tp_hasPwr ; if power is ON, go...
    inc     ctr_pipebad_canrx   ; power is off, count as bad RX
    sjmp    badPipeRqst         ; go ACK message but skip processing
tp_hasPwr:
    setb    PIPENEWMSG          ; indicate that new message arrived
badPipeRqst:
    lcall   clr_piperqst        ; re-enable listener
    ret     ; continue with main loop after rx handled

; *************************************************************************
; **  Received Get-Counters Request
; *************************************************************************
try_ctrsrqst:   ; request received by object 6?
    jnb     acc.6,try_isprqst
    lcall   read_ctrsrqst ; capture incoming msg
    jb      BADCANRX,badCtrsRqst    ; if BAD packet bits/length, skip it
;   sjmp    hndl_ctrsrqst  FALL THROUGH...
; *************************************************************************
; **  Payload handlers (hndl_*)
; *************************************************************************
; handle our payload just received (payload0 specs: ctr clear/bootROM copy)
hndl_ctrsrqst:
    mov     a,payload0  ; get clear flag
    push    acc
    acall   rply_ctrsrqst   ; build and send our reply
    pop     acc
    jnb     acc.0,no_ctrreset   ; if NO-RESET requested, skip ctr reset
    lcall   clr_ctrs    ; reset the CAN status counters
no_ctrreset:
badCtrsRqst:
    lcall   clr_ctrsrqst    ; re-enable listener
    ret     ; continue with main loop after rx handled

; *************************************************************************
; **  Received Jump2ISP Request Broadcast
; *************************************************************************
try_isprqst:     ; request received by object 7?
    jb      acc.7,do_isprqst
    ; the following return should never happen, but just in case....
    ret ; equiv. to:  sjmp loop_tail (and cleans up stack)

badIspRqst:
    lcall   clr_isprqst ; re-enable listener
    ret     ; continue with main loop after rx handled

do_isprqst:
    lcall   read_isprqst ; capture message details
    jb      BADCANRX,badIspRqst ; if BAD packet bits/length, skip it
    ; iff payload not exact, ignore this false msg
    mov     a,payload0
    cjne    a,#0xf0,badIspRqst
    mov     a,payload1
    cjne    a,#0x0d,badIspRqst
;   sjmp    hndl_isprqst     FALL THROUGH...
; --------------------------------------------------------------------------
; handle our jump message just received
hndl_isprqst:
    ; handle our jump to ISP request
    setb    c               ; set the carry bit (set POWER OFF)
    mov     PWRCTLVAL,c     ; set our in-RAM power control bit image
    mov     PWRCTRL,c       ; set our output power control line
    mov     payload0,#0x00  ; PRESET: we are HALTing (not US asked to go to ISP)
    mov     a,r4        ; get address from received message
    cjne    a,mod_addr,isp_pyld  ; if NOT this Widget, go...
    mov     payload0,#0x01  ; SET: we are Jumping to ISP (it WAS US)
isp_pyld:
    mov     a,payload0  ; get value we are sending...
    push    acc         ; save for branch below
    ;  reply to message (we got request, here's what we are doing)
    acall   rply_isprqst    ; build and send our reply
    lcall   waitx1cmplt ; loop util transmit completes
    lcall   clr_isprqst ; re-enable listener
    clr     EA          ; turn off interrupts
    lcall   reset_can   ; disable CAN controller
    ; if address IS this Widget go enter ISP
    pop     acc         ; restore so we know how to branch
    jnz     enterisp

; external control asked us get off the CAN bus
shutdown:
    ; we are shutting down...
    ; *********************
    ; **   halt here    ***
    ; *********************
    orl     pcon,#0x02  ; (PD=1) enter power down mode
halt:               ;  (really, next instru is NOT exec)
    sjmp    halt        ; iff get here, loop forever (until power is cycled)

; external control asked us to jump to ATMEL boot loader
enterisp:
    lcall   rqst_boot2can   ;   mark memory so that on WD fire we boot to ISP
canboot:
    clr     EA          ; turn off interrupts
    lcall   reset_can   ; disable CAN controller
    lcall   ena_bootrom ; place BOOT FLASH (FM1) into code space
    ; *********************
    ; **  entering ISP  ***
    ; *********************
    ;  NOTE: ff00 - User Start ISP (Keeping CAN setup)   <-- NO
    ;        f800 - Start ISP Bootloader @500Khz         <-- YES
    ljmp    0xf800  ; jump to ISP Bootloader Entry point

; --------------------------------------------------------------------------
; handle our payload just received (Module Config - OUT11-0 + PWR)
hndl_std_configure:
    mov     a,payload1  ; get (pxxxOOOO)
    mov     c,acc.7     ; get power control bit
    cpl     c           ; invert it
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit
    anl     a,#0x0f     ; isolate the OUT11-8 bits
    mov     b,a         ; save OUT11-OUT8
    mov     acc.7,c     ; or in CY (inverted PWR bit)
    mov     outbits118,a    ; save OUT11-8 in RAM
    mov     outs2_cpy1,a    ;  and 2nd copy for WD reset
    mov     a,p3        ; get current value
    anl     a,#0xf0     ; kill our output bits
    orl     a,b         ; or-in our new bits
    mov     b,a         ; re-save 8-11 to b (now with curr p3 upper bits)
    mov     a,payload0  ; get (OOOOOOOO)
    mov     outbits70,a     ; save OUT7-0 in RAM
    mov     outs2_cpy0,a    ;  and 2nd copy for WD reset
    mov     p2,a        ; write to our output pins 0-7
    mov     p3,b        ; write to our output pins 8-11
    ; get new values for analog channels
    clr     OUT1        ; (tst) strobe to mark beginning of 8-channel conversion
    setb    OUT1
    clr     OUT1
    setb    OUT1
    ; convert 8 channels AN0-7 and store results to memory
    lcall   precision_digitize
    ; get new values for digital channels
    mov     a,p0        ; get digital inputs
    mov     INBITS,a    ; store in bit-addressable RAM
    sjmp    snd_analog_rplys

; --------------------------------------------------------------------------
; handle our payload just received (Module Config - OUT62-0 + PWR)
hndl_mux_configure:
    mov     a,payload7  ; get (Pbbbbbbb)
    mov     c,acc.7     ; get power control bit
    cpl     c           ; invert it
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit
    ; prepare pwr bit to indicate 1st MUX pass
    ; (already have this): mov  a,payload7  ; re-get (Pbbbbbbb)
    clr     acc.7       ; override power bit (1st pass is 0)
    mov     payload7,a  ; rewrite with our power bit overridden
    ; write output values to mux and read inputs to dummy (ignored area)
    mov     r1,#adc_chan0   ; over-writing ADC storage ok since not yet used
    acall   rdwr_mux
    ; get new values for analog channels
    clr     OUT1        ; (tst) strobe to mark beginning of 8-channel conversion
    setb    OUT1
    clr     OUT1
    setb    OUT1
    ; convert 8 channels AN0-7 and store results to memory
    lcall   precision_digitize
    ; prepare pwr bit to indicate 2nd MUX pass
    mov     a,payload7    ; re-get (Pbbbbbbb)
    setb    acc.7         ; override power bit (2nd pass is 1)
    mov     payload7,a    ; rewrite with our power bit overridden
    ; write output values to mux and read inputs to payload area
    ;  over-writing output bits
    mov     r1,#payload0  ; store input bits over the top of our output bits
    acall   rdwr_mux
    ; build and send IN08 (payload[0-7] loaded by mux routine above)
    ;   r5 - stream - [00-0f]
    ;   r4 - device addr - [00-3f]
    ;   r3 - payload len (valid bytes in payload[0-7] (RAM))
    mov     r5,#RPL_IN08    ; send to this stream
    mov     r4,mod_addr     ; set my address for broadcast
    mov     r3,#8           ; set 8 byte payload
    lcall   page1xmit
    ; clear digital inputs not used in MUX mode
    clr     a               ; get zeros
    mov     INBITS,a        ; store in RAM
; ** common exit tail for all 3 hndl_*configure routines
snd_analog_rplys:
    ; build and send AN03
    acall   bld_an03
snd_after_03built:  ; alternate entry point when caller
                    ;   overrides one or more bits in AN03 payload[]
    lcall   page1xmit
    ; build and send AN47
    acall   bld_an47
    lcall   page1xmit
    ; finished transmission of last reply... reset H/W Watchdog
    lcall   reset_wd    ; reset our hardware timer (IHU is still active)
badCfgPktRx:            ; here to abort handling of configure pkt
    lcall   clr_cfgrqst     ; re-enable listener
    ret     ; continue with main loop after rx handled

; --------------------------------------------------------------------------
; rdwr_mux() - write 64 outputs to our latches, read in 64 input values
;              managing strobe controlling external latch hardware
;  INPUT:
;   r1 - pointing to location at which to store the input 8-bytes
;  OUTPUT:
;   None
;  SIDE-EFFECTS:
;   8 Bytes RAM pointed to by r1 now has new content
;   Registers acc, r0, r1, r2, r3, and b all destroyed
rdwr_mux:
; write the outputs and read inputs via the multiplexor
    mov     r2,#8       ; we've 8 latches which we read -n- write
    mov     r3,#0       ; initial latch address (we always start with zero)
    mov     r0,#payload0    ; get from locn which has had w/pwr-val fixed
    mov     a,p3        ; get current value
    anl     a,#P3MSK_BUT_LATCH  ; clear latch bits
    orl     a,#0x08     ; add in strobe bit (not asserted)
    mov     b,a         ; save register base value in b-reg
nxt_latch:
    mov     a,r3        ; (1) get latch address
    orl     a,b         ; (1) add in rest of port values (w/latch addr)
    mov     p3,a        ; (1) write latch address
    mov     p2,@r0      ; (2) write our output data
    clr     MX_STROBE   ; (1) assert STROBE
    mov     @r1,p0      ; (2) get input data
    setb    MX_STROBE   ; (1) de-assert STROBE
    inc     r0          ; (1) point to next output byte
    inc     r1          ; (1) point to next input byte
    inc     r3          ; (1) set next latch address
    djnz    r2,nxt_latch    ; (2) go do next latch iff not done all of them
    ret         ; return to caller

; --------------------------------------------------------------------------
; hndl_pipe_configure() - process payload just received
;                          (Module Config - OUT11-0 + PWR)
hndl_pipe_configure:
    mov     a,payload1  ; get (pxxxxx00)
    mov     c,acc.7     ; get power control bit
    cpl     c           ; invert it
    jc      hpc_noPwrOn ; if power not being turned on, go...
    clr     INACK       ; assert IN-ACK just before we turn on power
hpc_noPwrOn:
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit (turn on/off Module Pwr)
    jnc     hpc_noPwrOff
    setb    PIPEABORT   ; mark that pipe abort is needed (just turned OFF Module pwr)
hpc_noPwrOff:
    ; don't mess with byte-pipe used bits
    anl     a,#0x03     ; isolate the OUT9-8 bits
    mov     outbits118,a    ; save them in RAM
    mov     a,p3        ; get current value
    anl     a,#0xfc     ; kill existing OUT9-8 bits
    orl     a,outbits118 ;or-in our new OUT9-8 bits
    ; NOTE: p2 is not written due to being used in byte-pipe xfers!
    mov     p3,a        ; set our bits in P3
    ;
    mov     a,payload0  ; get (00xxxxxx)
    jnb     acc.7,hpc_noRstPipe ; skip reset if not requested
    setb    PIPEABORT   ; mark that pipe abort is needed (RESET-RQST is why)
hpc_noRstPipe:
    jnb     acc.6,hpc_noRstCtrs ; skip reset if not requested
    acall   clr_pipe_ctrs       ; go clear them since we were told to
hpc_noRstCtrs:
    ; get new values for analog channels
    clr     OUT1        ; (TST) strobe to mark beginning of 6-channel conv
    setb    OUT1
    clr     OUT1
    setb    OUT1
    ; convert 6 channels AN1-3,AN5-7 and store results to memory
    ;  (AN3,AN4 bits, in this mode, are digital inputs)
    lcall   precision_digitize
    ; now place status bits for anxx build to load
    mov     INBITS,#0   ; first, we have no values...
    mov     c,PIPEWASBUSY   ; place this value in chan0 slot
    mov     INBITS.0,c
    mov     c,PIPEINBUSY    ; place these values in chan1 slot
    orl     c,PIPEOUTBUSY
    mov     INBITS.1,c
    ; build AN03 into payload[]
    acall   bld_an03
    ; fill in crror counters over top of prepopulated AN03
    mov     a,ctr_pipein_tmot
    mov     b,ctr_pipeout_tmot
    acall   packctrs    ; limit to 4-bit values and pack into 1 byte
    mov     payload0,a
    ; setup counter (in payload byte 1, lsnibble)
    mov     b,ctr_pipebad_canrx
    clr     a
    acall   packctrs    ; limit to 4-bit values and pack into 1 byte
    mov     b,payload1  ; get payload1 (00000000)
    xch     a,b         ; curr payload to a, ctr to b
    anl     a,#0xf0     ; clear space for counter (0000xxxx)
    orl     a,b         ; now fill-in counter (0000cccc)
    mov     payload1,a  ; place back into payload
    ljmp    snd_after_03built   ; now, send it and AN47, too

; --------------------------------------------------------------------------
; Generate and send our reply message indicating what path we are taking
; INPUT:
;   payload0 - already setup by caller
;
rply_isprqst:
    ; send message
    mov     r3,#1           ; set payload length of 1 byte
    mov     r4,mod_addr     ; ADDR: our own address
    mov     r5,#RPL_JMP2ISP ; STREAM: reply to get counters msg
rply_xmit:
    lcall   page1xmit
    ; finished transmission of last reply... reset H/W Watchdog
    lcall   reset_wd    ; reset our hardware timer (IHU is still active)
    ret ; return to caller

; --------------------------------------------------------------------------
; Generate and send our get-counters reply message
;
rply_ctrsrqst:
    ; setup our message payload
    mov     r0,#payload0    ; get address of payload array
    mov     @r0,CANTEC      ; write val to payload0
    inc     r0              ; point next
    mov     @r0,CANREC      ; write val to payload1
    inc     r0              ; point next
    mov     a,ctr_wrong_pkt
    mov     b,ctr_can_berr
    acall   packctrs        ; place counters into same byte
    mov     @r0,a           ; write val to payload2
    inc     r0              ; point next
    mov     a,ctr_can_serr
    mov     b,ctr_can_cerr
    acall   packctrs        ; place counters into same byte
    mov     @r0,a           ; write val to payload3
    inc     r0              ; point next
    mov     a,ctr_can_ferr
    mov     b,ctr_can_aerr
    acall   packctrs        ; place counters into same byte
    mov     @r0,a           ; write val to payload4
    inc     r0              ; point next
    mov     a,ctr_can_boff
    mov     b,ctr_can_errp
    acall   packctrs        ; place counters into same byte
    mov     @r0,a           ; write val to payload5
    inc     r0              ; point next
    clr     a
    mov     @r0,a           ; write val to payload6
    inc     r0              ; point next
    mov     a,ctr_wd_resets
    mov     @r0,a           ; write val to payload7
    ; send message
    mov     r3,#8           ; set payload length
    mov     r4,mod_addr         ; ADDR: our own address
    mov     r5,#RPL_GET_CTRS    ; STREAM: reply to get counters msg
    sjmp    rply_xmit   ; go xmit message and return to caller

; --------------------------------------------------------------------------
; packctrs() - pack two 8-bit counters into 8 bits
; INPUTS:
;   a - ctr is capped at 15 and placed into hi nybble
;   b - ctr is capped at 15 and placed into lo nybble
; OUTPUTS:
;   a - combined value
; SIDE-EFFECTS:
;   cy, b are destroyed
packctrs:
    acall   cap_at15        ; cap ctr(a) at 15
    rl      a               ; move to MsNibble
    rl      a
    rl      a
    rl      a
    xch     a,b             ; save in b, get other ctr to a
    acall   cap_at15        ; cap ctr(a) at 15
    orl     a,b             ; combine the two capped counters
    ret ; return to caller

cap_at15:
    cjne    a,#16,cap2
cap2: jc    capok       ; <16, go
    mov     a,#15       ; >15, set to 15
capok:
    ret ; return to caller

; --------------------------------------------------------------------------
; clr_pipe_ctrs() - clear all 'pipe' event counters
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   counters in RAM are zero'd
clr_pipe_ctrs:
    mov     ctr_pipein_tmot,#0  ; clear pipe-input event counter
    mov     ctr_pipeout_tmot,#0 ; clear pipe-output event counter
    mov     ctr_pipebad_canrx,#0    ; clear bad-rx event counter
    ; TBA  ??Clear two AN03 flags, too??
    ret ; return to caller

; --------------------------------------------------------------------------
; Generate and send our Census (who's on the bus) reply message
;
rply_cenrqst:
    ; setup our message payload
    mov     r0,#payload0    ; get address of payload array
    mov     a,mod_bits  ; get RAW SR settings
    mov     @r0,a       ; write pkt+0
    inc     r0
; FILL with 3 checksums deemed most useful
    mov     r2,#6
    mov     a,r1        ; preserve r1
    push    acc
    mov     r1,#ram_cksum   ; lowest address of 3 sums
rb_fill:
    mov     a,@r1
    inc     r1
    mov     @r0,a
    inc     r0
    djnz    r2,rb_fill
    pop     acc         ; restore r1
    mov     r1,a
    clr     a           ; set index to zero
    mov     dptr,#sw_ver    ; point to our SW version
    movc    a,@a+dptr   ; get it
    mov     @r0,a       ; write to last byte of packet
    ; send message
    mov     r3,#8       ; set payload length
    mov     r4,mod_addr     ; load our own address
    mov     r5,#RPL_CENSUS
    ajmp    rply_xmit   ; go xmit message and return to caller

; --------------------------------------------------------------------------
; bld_an03() - Generate our AN03 response (into payload[] bytes)
; INPUTS:
;   None
; OUTPUTS:
;   R5 - stream id for AN03 packet
;   R4 - this modules address
;   R3 - length of the AN03 packet in bytes
; SIDE-EFFECTS:
;   Various RAM locations are moved into place in payload[] array
;   Destroys R3,R4,R5,acc,cy
bld_an03:
    ; setup AN03 payload
    ;   r5 - stream - [00-0f]
    ;   r4 - device addr - [00-3f]
    ;   r3 - payload len (payload assumed in payload0-payload7 (RAM))
    mov     r5,#RPL_AN03    ; send to this stream
    mov     r4,mod_addr ; set my address for broadcast
    mov     r3,#8       ; set 8 byte payload
    ; setup payload bytes
    mov     a,adc_chan0+1
    mov     payload0,a
    mov     a,adc_chan0+0
    mov     c,INBITS.0
    mov     acc.7,c
an03_ckboot:
    jnb     BOOT_OK, an03_ckeram
    setb    acc.6   ;BOOTFLASH chksum matches (an03, chan 0, bit 6)
an03_ckeram:
    jnb     ERAM_OK, an03_endchks
    setb    acc.5   ;ERAM chksum matches (an03, chan 0, bit 5)
an03_endchks:
    mov     payload1,a
    mov     a,adc_chan1+1
    mov     payload2,a
    mov     a,adc_chan1+0
    mov     c,INBITS.1
    mov     acc.7,c
    mov     payload3,a
    mov     a,adc_chan2+1
    mov     payload4,a
    mov     a,adc_chan2+0
    mov     c,INBITS.2
    mov     acc.7,c
    mov     payload5,a
    mov     a,adc_chan3+1
    mov     payload6,a
    mov     a,adc_chan3+0
    mov     c,INBITS.3
    mov     acc.7,c
    mov     payload7,a
    ret ; return to caller

; --------------------------------------------------------------------------
; bld_an03() - Generate our AN47 response (into payload[] bytes)
; INPUTS:
;   None
; OUTPUTS:
;   R5 - stream id for AN47 packet
;   R4 - this modules address
;   R3 - length of the AN47 packet in bytes
; SIDE-EFFECTS:
;   Various RAM locations are moved into place in payload[] array
;   Destroys R3,R4,R5,acc,cy
bld_an47:
    ; setup AN47 payload
    ;   r5 - stream - [00-0f]
    ;   r4 - device addr - [00-3f]
    ;   r3 - payload len (payload assumed in payload0-payload7 (RAM))
    mov     r5,#RPL_AN47    ; send to this stream
    mov     r4,mod_addr     ; set my address for broadcast
    mov     r3,#8           ; set 8 byte payload
    ; setup payload bytes
    mov     a,adc_chan4+1
    mov     payload0,a
    mov     a,adc_chan4+0
    mov     c,INBITS.4
    mov     acc.7,c
    mov     payload1,a
    mov     a,adc_chan5+1
    mov     payload2,a
    mov     a,adc_chan5+0
    mov     c,INBITS.5
    mov     acc.7,c
    mov     payload3,a
    mov     a,adc_chan6+1
    mov     payload4,a
    mov     a,adc_chan6+0
    mov     c,INBITS.6
    mov     acc.7,c
    mov     payload5,a
    mov     a,adc_chan7+1
    mov     payload6,a
    mov     a,adc_chan7+0
    mov     c,INBITS.7
    mov     acc.7,c
    mov     payload7,a
    ret ; return to caller

; --------------------------------------------------------------------------
; Watch-dog configure recovery system
; --------------------------------------------------------------------------
reload_config:
; **  DISPATCH to appropriate RELOAD MECH. (std, mux -or- pipe)
    jb      PIPE_MODE,reload_pipe
    jb      MUX_MODE,reload_mux
    ; fall THRU to standard-mode MECH.
reload_std:
    ; determine of copies are good.  If they are, write config from one of them
    mov     a,outs1_cpy0
    cjne    a,outs2_cpy0,exit_stdcfg
    mov     a,outs1_cpy1
    cjne    a,outs2_cpy1,exit_stdcfg
    ; write config outputs from low mem copy
good_stdcfg:
    mov     a,outs1_cpy1    ; get (pxxxOOOO)
    mov     c,acc.7     ; get power control bit
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit
    anl     a,#0x0f     ; isolate the OUT11-8 bits
    mov     b,a
    mov     a,p3        ; get current value
    anl     a,#0xf0     ; kill our output bits (11-8)
    orl     a,b         ; or-in our new bits
    mov     b,a         ; save 8-11 in b
    mov     a,outs1_cpy0    ; get (OOOOOOOO)
    mov     p2,a        ; write to our output pins 0-7
    mov     p3,b        ; write to our output pins 8-11
exit_stdcfg:
    ret ; return to caller

    ; reload multiplex-mode MECH.
reload_mux:
    ; determine of copies are good.  If they are, write config from one of them
    mov     a,outs1_cpy0
    cjne    a,outs2_cpy0,exit_muxcfg
    mov     a,outs1_cpy1
    cjne    a,outs2_cpy1,exit_muxcfg
    mov     a,outs1_cpy2
    cjne    a,outs2_cpy2,exit_muxcfg
    mov     a,outs1_cpy3
    cjne    a,outs2_cpy3,exit_muxcfg
    mov     a,outs1_cpy4
    cjne    a,outs2_cpy4,exit_muxcfg
    mov     a,outs1_cpy5
    cjne    a,outs2_cpy5,exit_muxcfg
    mov     a,outs1_cpy6
    cjne    a,outs2_cpy6,exit_muxcfg
    mov     a,outs1_cpy7
    cjne    a,outs2_cpy7,exit_muxcfg
    ; write config outputs from low mem copy
good_muxcfg:
    mov     a,outs1_cpy7    ; get (Pbbbbbbb)
    mov     c,acc.7     ; get power control bit
    cpl     c           ; invert it
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit
exit_muxcfg:
    ret ; return to caller

    ; reload pipe-mode MECH.
reload_pipe:
    ; determine of copies are good.  If they are, write config from one of them
    mov     a,outs1_cpy0
    cjne    a,outs2_cpy0,exit_pipecfg
    mov     a,outs1_cpy1
    cjne    a,outs2_cpy1,exit_pipecfg
    ; write config outputs from low mem copy
good_pipecfg:
    mov     a,outbits98 ; get (pxxxxx00)
    mov     c,acc.7     ; get power control bit
    cpl     c           ; invert it
    mov     PWRCTLVAL,c ; record our power control value
    mov     PWRCTRL,c   ; set our output bit
    ; don't mess with byte-pipe used bits
    orl     a,#0xfc     ; load reset value into all bits but OUT9,OUT8
    ; NOTE: p2 is not written due to being used in byte-pipe xfers!
    mov     p3,a        ; set our bits in P3
exit_pipecfg:
    ret ; return to caller
; --------------------------------------------------------------------------
; MODULE simulation: (for pipe check-out)
; --------------------------------------------------------------------------
; WRITE 5 byte-pipe transctions of 8-bytes each (5x8 = 40)
;  abort if 'x' pressed
;  pause after each 8-byte block
;   show the 8-byte blocks
do_test:
    orl     psw,#SEL_BNK3     ; byte-pipe regs are in BANK3
    mov     r7,#5             ; we will send 5 8-byte groups
    mov     payload0,#'0'     ; start with 0x30
writePipeGroup:
    acall   genPaylod         ; generate next 7 bytes of payload
    mov     r6,#8             ; we gather and display in groups of 8 requests
    mov     r0,#payload0      ; point to payload bytes
writePipeByte:
    ; wait de-assert ACK
haveOutACK:
    jnb     OUTACK,haveOutACK   ; wait until user clears their flag
    ; get next byte to write
    mov     a,@r0             ; get byte to write
    mov     DATAOUT,a         ; write byte
    inc     r0                ; point to next locn
    ; assert REQuest
    clr     OUTREQ            ; indicate that it's ready
    ; wait ACK
haveNoOutACK:
    jb      OUTACK,haveNoOutACK ; wait until user ACKs it
    ; deassert REQ
    setb    OUTREQ            ; clear our DATA ready flag
    ; loop....
    djnz    r6,writePipeByte  ; loop if not done... (not all eight written)
    ; no, setup next payload
    inc     payload0          ; bump payload starting byte
    djnz    r7,writePipeGroup ; loop if not done... (not all 5 payloads written)
    anl     psw,#SEL_BNK0     ; back to our main regs
    ; hold here until user removes ack, so upper level routine doesn't kick in
waitDoneAck:
    jnb     OUTACK,waitDoneAck   ; loop until byte is no-longer acked
    ret ; return to caller

genPaylod:
    mov     r6,#7           ; generate 7 more bytes
    mov     r0,#payload0    ; point to payload bytes
    mov     a,@r0           ; get last starting byte
phylByte:
    inc     a               ; get next value
    inc     r0              ; point next locn
    mov     @r0,a           ; write new byte value
    djnz    r6,phylByte     ; loop if not done...
    ret ; return to caller

;
;  End of Power-On initialization
;
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Serial Interface Routines
; Copyright (C) 2002-2004 by Stephen Moraco,KC0FTQ
; $Id: serial.a51,v 1.17 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
; init_sio() - Initialize the serial I/O Port/Baudrate Generator
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Serial I/O is setup at 9600baud and ready for use
;   NOTE: if USE_SERIAL compile switch is NOT defined then the BRG is
;         not started and no serial support is avail. In this case,
;         this code simply init's the hardware which then sits idle.
init_sio:
    mov     r2,#204     ; X2 mode: RCAP2L value
    mov     r1,#230     ; X1 mode: RCAP2L value
;   dosioinit() is alternate entry point for initializing for diff. baud rate
;      w/baud rate config values passed in r1,r2
dosioinit:
    ; setup Timer 2 as baud-rate generator, and UART for 8-bit work
    clr     a
    mov     T2CON,a     ; force reset state
    mov     T2MOD,a     ;  w/no t2 output
    ; load counter values for 9600 baud w/8MHz (either X1 or X2 mode!)
    mov     a,#255      ; a 0xff
    mov     RCAP2H,a
    mov     TH2,a
    mov     a,CKCON     ; get X2B: running in X2 mode?
    jb      acc.0,x2_9600   ; yes, go setup X2 divisor
x1_9600:
    mov     a,r1        ; X1: RCAP2L value
    sjmp    set_9600
x2_9600:
    mov     a,r2        ; X2: RCAP2L value
set_9600:
    mov     RCAP2L,a
    mov     TL2,a
    ; now setup UART
    mov     SCON,#0x53  ; set (SM1,REN,TI,RI) 8 bit UART mode
    mov     T2CON,#0x30 ; set (RCLK,TCLK)
    ; NOTE: timer2 (baud-rate generator) not started, serial not used
    ret

;
;  End of Serial Interface Routines
;
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - CAN I/O Routines
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
;  Original work contributed by John Conner, NJ0C
;  CAN addressing scheme proposed by Bdale Garbee, KB0G
; $Id: canio.a51,v 1.82 2004/09/29 23:12:55 stephen Exp $
; --------------------------------------------------------------------------
;
; CAN Module Addressing
; ---------------------
;
; For the AMSAT CAN Modules the 11 bit CAN Bus message ID space is
; structured as follows:
;
;  |10| 9| 8| 7| 6| 5| 4| 3| 2| 1| 0|
;    |  |  |  |  |  |  |  |  |  |  +| These bits represent the address of
;    |  |  |  |  |  |  |  |  |  +---| the module. The will be set with
;    |  |  |  |  |  |  |  |  +------| hard wired jumpers on the module.
;    |  |  |  |  |  |  |  +---------| The IHU will have the lowest possible
;    |  |  |  |  |  |  +------------| address - 0x01. This is the lowest
;    |  |  |  |  |  +---------------| valid CAN message ID. This is also the
;    |  |  |  |  |                  | highest priority address on the CAN BUS.
;    |  |  |  |  |                  | Addressing of actual modules is
;    |  |  |  |  |                  | covered in the User Manual.
;    |  v  v  v  v
;    |                                *** IHU to Module ***
;    |  0  0  0  0 ---------------- - 0x00MM Module Configure Command
;    |  0  0  0  1 ---------------- - 0x04MM Byte-pipe data to write to Module
;    |  0  0  1  0 ---------------- - 0x08MM TBD
;    |  0  0  1  1 ---------------- - 0x0CMM TBD
;    |  0  1  0  0 ---------------- - 0x10MM TBD TEST TEST TEST
;    |  0  1  0  1 ---------------- - 0x14MM Module Census Query (Broadcast)
;    |                                 (the following two for Dev Testing Only)
;    |  0  1  1  0 ---------------- - 0x18MM Module Read Counters
;    |  0  1  1  1 ---------------- - 0x1CMM Module Jump to ISP Loader
;    |
;    |                                *** Module to IHU ***
;    |  1  0  0  0 ---------------- - 0x20MM Module Status IN08 (mux mode only)
;    |  1  0  0  1 ---------------- - 0x24MM Module Status AN03 (w/IN03,stdmode)
;    |  1  0  1  0 ---------------- - 0x28MM Module Status AN47 (w/IN47,stdmode)
;    |  1  0  1  1 ---------------- - 0x2CMM Byte-pipe data read from Module
;    |  1  1  0  0 ---------------- - 0x30MM TBD
;    |  1  1  0  1 ---------------- - 0x34MM Module Census Response
;    |                                 (the following two for Dev Testing Only)
;    |  1  1  1  0 ---------------- - 0x38MM Module Read Counters Response
;    |  1  1  1  1 ---------------- - 0x3cMM Module Jump to ISP Loader ACK
;    |
;    |
;    + -----------------------------| This bit identifies messages
;                                     that adhere to this protocol.
;                                     A zero represents a hi-priority
;                                     message, which implements this
;                                     protocol. A one represents
;                                     a low priority bulk data message.
;
; So... this can be thought of as PSSSSAAAAAA with the following legend:
;
;          P      - Protocol (0=this protocol, 1=low pri. bulk data)
;          SSSS   - Stream ID
;          AAAAAA - Widget Address 0-63 (0x00-0x3F)
;
; While actual assignments are up to Bdale, for now, here's what I'm using
; for 0-63 (0x00-0x3F):  -Stephen

;   ADDR 5:0       Use
; -----------   ---------------------
;   0x00         Not used on CAN, reserved
;   0x01-3F      Modules
; -----------   ---------------------
;
; Also, while I'm thinking about it, here's the mode-bit def'n I'm using:
;
;   MODE 1:0       Meaning
; -----------   ---------------------
;   0b00         Reserved
;   0b01         Byte-pipe Mode
;   0b10         Multiplexed Mode
;   0b11         Standard Mode
; -----------   ---------------------
;
; Definitions
; -----------
;
;  Widget - CAN Module Board
;  Module - A box of stuff on spacecraft that includes a Widget
;  bus    - CAN (Controller Area Network)
;  mode   - Standard or Multiplexed
;  latch  - 8 bits in multiplexed mode "latch.7 .. latch.0"
;
; CAN Module Messages
; -------------------
;
; This message definition implements a command/status bus used to communicate
; between the IHU and per-Module CAN Widgets on the spacecraft.
;
; Widgets on the bus provide digital outputs, digital inputs and analog
; inputs. There are three modes a widget can be configured for, that differ in
; the number of digital inputs/outputs and analog inputs and how these are
; presented to a Module.
;
; The three modes are called Standard, Multiplexed and Byte-pipe due to how
; the data is presented to/read from the Module.
;
; In Standard mode, outputs are presented directly to the Module as 12 simple
; parallel bits and the inputs are read from the Module as a single 8-bit
; input port.
;
; The 0x00MM Module Configure Command and the 0x24MM and 0x28MM response
; packets implement the Standard mode.
;
; The Multiplexed mode gets its name from the fact that the 63 outputs and
; the 64 inputs are multiplexed over simple 8-bit ports and must be latched
; by the Module. The input and output ports share 3 latch address lines and a
; single strobe line.
;
; The 0x00MM Module Configure Command and the 0x20MM, 0x24MM and 0x28MM
; response packets implement the Multiplexed mode.
;
; In Byte-pipe mode, the standard mode ins/outs are reduced while a new
; byte transfer capability is added. In this mode, there are no digital
; inputs, two outputs and only 6 analog inputs.
;
; The 0x00MM Module Configure Command and the 0x24MM and 0x28MM response
; packets along with the 0x04MM and 0x2CMM 8-byte transfer packets implement
; the Byte-pipe mode.
;
;
; --------------------------------------------------------------------------
; 0x00MM Module Configure Command [Length 2=Standard/Length 8=Multiplexed]
; --------------------------------------------------------------------------
;
; This command packet is used to send digital output values to the Module
; from the IHU.  It is also used to turn the Module on and off.
;
; This command packet exists in three forms, one for standard mode, one for
; Multiplexed mode, and one for Byte-pipe mode.  In standard mode only 12
; output bits plus the power control bit are sent to the Module.  Therefore
; only a 2 byte packet is needed. However, in Multiplexed mode 63 output
; bits plus the power control bit are sent to the Module so a full 8-byte
; packet is used. The Byte-pipe mode uses the standard mode packet but
; less bits (2 output bits plus the power control bit) are used.
;
;*** Standard Mode ***
;
; The Standard mode Module Configure Command packet consists of 2 bytes.
; Unused bits will be 0. The module uses the following bits in the
; packet.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Out7..Out0
;     1.7         PwrCtl - 1 Module power ON, 0 Module power OFF
;     1.6-4       Reserved (0's)
;     1.3-0       Out11..Out8
;  ------------  -------------------------------------------------------
;
; A Standard mode Module must send two packets in response to this packet.
; They are 0x24MM and 0x28MM.
;
;*** Multiplexed Mode ***
;
; The Multiplexed mode Module Configure Command packet consists of 8 bytes.
; There are no unused bits. The module uses the following bits in the
; packet.
;
; NOTE: this is setup specifically so that the byte offset into the message
; corresponds to the latch address.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Output Latch 0 bits 7..0
;     1.7-0       Output Latch 1 bits 7..0
;     2.7-0       Output Latch 2 bits 7..0
;     3.7-0       Output Latch 3 bits 7..0
;     4.7-0       Output Latch 4 bits 7..0
;     5.7-0       Output Latch 5 bits 7..0
;     6.7-0       Output Latch 6 bits 7..0
;     7.7         PwrCtl - 1 Module power ON, 0 Module power OFF
;     7.6-0       Output Latch 7 bits 6..0 (There is NO bit 7 of latch 7)
;  ------------  -------------------------------------------------------
;
; A Multiplexed mode Module must send three packets in response to receiving
; this packet. They are 0x20MM, 0x24MM and 0x28MM.
;
; NOTE: Bit 7 of Latch 7 will always be written as a 1 to the Module
;
;*** Byte-pipe Mode ***
;
; The Byte-pipe mode Module Configure Command packet consists of 2 bytes.
; Unused bits will be 0. The module uses the following bits in the
; packet. (NOTE: this is nearly identical to the standard mode packet
; with many of the output bits simply ignored. This is done to simplify
; the implementation of this mode.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7         ResetPipes - 1 Hard-reset pipe IN & OUT, 0 Do not
;     0.6         ClrCounters - 1 Clear pipe event ctrs, 0 Do not
;     0.5-0       Reserved (0's)
;     1.7         PwrCtl - 1 Module power ON, 0 Module power OFF
;     1.6-2       Reserved (0's)
;     1.1-0       Out9..Out8  [Module defined]
;  ------------  -------------------------------------------------------
;
; A Byte-pipe mode Module must send two packets in response to this packet.
; They are 0x24MM and 0x28MM.
;
;
; --------------------------------------------------------------------------
; 0x20MM Module Status IN08 (multiplex mode only)
; --------------------------------------------------------------------------
; This is the 1st of three packets sent by a module to the IHU in reponse to
; a Multiplexed 0x00MM Module Configure Command packet.
;
; This packet carries the 64 digital input values from the Module back to the
; IHU.
;
; The Module Status IN08 response packet consists of 8 bytes. There are no
; unused bits. The module uses the following bits in the packet.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Input Latch 0 bits 7..0
;     1.7-0       Input Latch 1 bits 7..0
;     2.7-0       Input Latch 2 bits 7..0
;     3.7-0       Input Latch 3 bits 7..0
;     4.7-0       Input Latch 4 bits 7..0
;     5.7-0       Input Latch 5 bits 7..0
;     6.7-0       Input Latch 6 bits 7..0
;     7.7-0       Input Latch 7 bits 7..0
;  ------------  -------------------------------------------------------
;
; NOTE: this is setup specifically so that the byte offset into the message
; corresponds to the latch address.
;
; NOTE2: in Standard mode the digital input bits are carried in the high
; order bits of the analog data [see: 0x24MM and 0x28MM] so this packet
; is not used.
;
;
; --------------------------------------------------------------------------
; 0x24MM Module Status AN03 (w/IN03, standard mode)
; --------------------------------------------------------------------------
; In Standard mode this the 1st of two packets sent by a Module to the IHU in
; response to a 0x00MM Module Configure Command packet.  In Multiplexed mode,
; this is the 2nd of three packets sent to the IHU by Module.
;
; This packet, in both modes, contains the 10-bit values for Analog Channels
; 0-3. [See 0x28MM - data for Analog Channels 4-7.]
;
; In Standard mode this packet also carries four of the eight digitial inputs
; (In0-In3).  [See 0x28MM - data for Digital Inputs 4-7.  See 0x20MM for the
; Multiplexed mode Digital Inputs.]
;
; The 0x24MM Module Status AN03 response packet consists of 8 bytes. Unused
; bits will be 0.  The module uses the following bits in the packet.
;
;*** Standard Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Analog Channel 0 bits 7..0
;     1.7         Digital In0
;     1.6         DEBUG BOOT FLASH CHKSUM: 1=Valid, 0=invalid DEBUG
;     1.5         DEBUG ERAM CHKSUM: 1=Valid, 0=invalid       DEBUG
;     1.4-2       reserved (0's)
;     1.1-0       Analog Channel 0 bits 9..8
;     2.7-0       Analog Channel 1 bits 7..0
;     3.7         Digital In1
;     3.6-2       reserved (0's)
;     3.1-0       Analog Channel 1 bits 9..8
;     4.7-0       Analog Channel 2 bits 7..0
;     5.7         Digital In2
;     5.6-2       reserved (0's)
;     5.1-0       Analog Channel 2 bits 9..8
;     6.7-0       Analog Channel 3 bits 7..0
;     7.7         Digital In3
;     7.6-2       reserved (0's)
;     7.1-0       Analog Channel 3 bits 9..8
;  ------------  -------------------------------------------------------
;
;*** Multiplexed Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Analog Channel 0 bits 7..0
;     1.7         Reserved (0)
;     1.6         DEBUG BOOT FLASH CHKSUM: 1=Valid, 0=invalid DEBUG
;     1.5         DEBUG ERAM CHKSUM: 1=Valid, 0=invalid       DEBUG
;     1.4-2       Reserved (0's)
;     1.1-0       Analog Channel 0 bits 9..8
;     2.7-0       Analog Channel 1 bits 7..0
;     3.7-2       Reserved (0's)
;     3.1-0       Analog Channel 1 bits 9..8
;     4.7-0       Analog Channel 2 bits 7..0
;     5.7-2       Reserved (0's)
;     5.1-0       Analog Channel 2 bits 9..8
;     6.7-0       Analog Channel 3 bits 7..0
;     7.7-2       Reserved (0's)
;     7.1-0       Analog Channel 3 bits 9..8
;  ------------  -------------------------------------------------------
;
; NOTE: this packet differs from the Standard mode form in that the
;       In0-In3 bits are not present and are set to zero.
;
;*** Byte-pipe Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-4       PipeHealthA: COUNT of input-side timeouts [0-14,15]
;     0.3-0       PipeHealthB: COUNT of output-side timeouts [0-14,15]
;     1.7         PipeHealthC: FLAG= 1 if Reset rqstd while pipe was busy, 0 NOT
;     1.6         DEBUG BOOT FLASH CHKSUM: 1=Valid, 0=invalid DEBUG
;     1.5         DEBUG ERAM CHKSUM: 1=Valid, 0=invalid       DEBUG
;     1.4         reserved (0's)
;     1.3-0       PipeHealthD: COUNT of CAN Msgs rcvd w/Pwr Off [0-14,15]
;     1.1-0       Reserved (0)
;     2.7-0       Analog Channel 1 bits 7..0
;     3.7         PipeHealthE: FLAG= 1 if either Pipe-IN and/or OUT is busy, 0 NOT
;     3.6-2       Reserved (0's)
;     3.1-0       Analog Channel 1 bits 9..8
;     4.7-0       Analog Channel 2 bits 7..0
;     5.7         Reserved (0's)
;     5.6-2       Reserved (0's)
;     5.1-0       Analog Channel 2 bits 9..8
;     6.7-0       Analog Channel 3 bits 7..0
;     7.7         Reserved (0's)
;     7.6-2       Reserved (0's)
;     7.1-0       Analog Channel 3 bits 9..8
;  ------------  -------------------------------------------------------
;
; NOTE: this packet differs from the Standard mode form in that the
;       In0-In3 bits and Analog channel zero are not present in pipe
;       mode.  Some of these locations are instead used to carry
;       byte-pipe health indications back to the IHU.
;       [See PipeHealthA..E above]
;
;
; --------------------------------------------------------------------------
; 0x28MM Module Status AN47 (w/IN47, standard mode)
; --------------------------------------------------------------------------
; In Standard mode and Byte-pipe mode this the 2nd of two packets sent by
; a Module to the IHU in response to a 0x00MM Module Configure Command
; packet.  In Multiplexed mode, this is the 3rd of three packets sent to
; the IHU by Module.
;
; This packet, in both modes, contains the 10-bit values for Analog channels
; 4-7. [See 0x24MM - data for Analog Channels 0-3.]
;
; In Standard mode this packet also carries four of the eight digitial inputs
; (In4-In7). [See 0x28MM - data for Digital Inputs 0-3.  See 0x20MM for the
; Multiplexed mode Digital Inputs.]
;
; The 0x28MM Module Status AN47 response packet consists of 8 bytes. Unused
; bits will be 0.  The module uses the following bits in the packet.
;
;*** Standard Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Analog Channel 4 bits 7..0
;     1.7         Digital In4
;     1.6-2       Reserved (0's)
;     1.1-0       Analog Channel 4 bits 9..8
;     2.7-0       Analog Channel 5 bits 7..0
;     3.7         Digital In5
;     3.6-2       Reserved (0's)
;     3.1-0       Analog Channel 5 bits 9..8
;     4.7-0       Analog Channel 6 bits 7..0
;     5.7         Digital In6
;     5.6-2       Reserved (0's)
;     5.1-0       Analog Channel 6 bits 9..8
;     6.7-0       Analog Channel 7 bits 7..0
;     7.7         Digital In7
;     7.6-2       Reserved (0's)
;     7.1-0       Analog Channel 7 bits 9..8
;  ------------  -------------------------------------------------------
;
;*** Multiplexed Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Analog Channel 4 bits 7..0
;     1.7-2       Reserved (0's)
;     1.1-0       Analog Channel 4 bits 9..8
;     2.7-0       Analog Channel 5 bits 7..0
;     3.7-2       Reserved (0's)
;     3.1-0       Analog Channel 5 bits 9..8
;     4.7-0       Analog Channel 6 bits 7..0
;     5.7-2       Reserved (0's)
;     5.1-0       Analog Channel 6 bits 9..8
;     6.7-0       Analog Channel 7 bits 7..0
;     7.7-2       Reserved (0's)
;     7.1-0       Analog Channel 7 bits 9..8
;  ------------  -------------------------------------------------------
;
; NOTE: this packet differs from the Standard mode form in that the
;       In4-In7 bits are not present and are set to zero.
;
;*** Byte-pipe Mode ***
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Reserved (0's)
;     1.7-0       Reserved (0's)
;     2.7-0       Analog Channel 5 bits 7..0
;     3.7-2       Reserved (0's)
;     3.1-0       Analog Channel 5 bits 9..8
;     4.7-0       Analog Channel 6 bits 7..0
;     5.7-2       Reserved (0's)
;     5.1-0       Analog Channel 6 bits 9..8
;     6.7-0       Analog Channel 7 bits 7..0
;     7.7-2       Reserved (0's)
;     7.1-0       Analog Channel 7 bits 9..8
;  ------------  -------------------------------------------------------
;
; NOTE: this packet differs from the Standard mode form in that the
;       In4-In7 bits are not present and are set to zero. Also, analog
;       channel 4 is not available in this mode so is set to zero's.
;
;
; --------------------------------------------------------------------------
; 0x04MM Byte-pipe data to write to Module (Byte-pipe mode only)
; --------------------------------------------------------------------------
;
;
; --------------------------------------------------------------------------
; 0x2CMM Byte-pipe data read from Module (Byte-pipe mode only)
; --------------------------------------------------------------------------
;
;
; --------------------------------------------------------------------------
; 0x14MM Module Census Query (Broadcast)  [0-byte payload]
; --------------------------------------------------------------------------
; This message is used to poll a bus to see what Widgets are powered
; up/present.
;
; Since this is a broadcast, the address part of the 11-bit ID contains
; the sender's address, not the usual address of the intended receiver.
;
; Widgets receiving this message should reply to their own address with a
; 0x34MM response packet properly filled in.  At first this seems wierd,
; but it prevents collisions on CAN bus (all replying to same address) and
; also provides for responses arriving to the requesting device in natural
; widget-priority order.  The querying device simply listens for all
; 0x34MM packets irrespective of the sending address.
;
; A device will send this packet then receive responses for a fixed amount of
; time thereafter (15 mSec should be sufficient for 63 devices on a bus.)
; After this time expires it stops listening and assumes all powered-up
; devices have responded.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;   *** There is NO message content (payload) for this packet ***
;  ------------  -------------------------------------------------------
;
;
; --------------------------------------------------------------------------
; 0x34MM Module Census Response  [8-byte payload]
; --------------------------------------------------------------------------
; A Widget constructs and sends one of these packets whenever it receives a
; 0x14MM Module Census Query packet.  The widget must address this packet
; to it's own address.  The Qeurying device is listening for all 0x34MM
; packets ignoring the address field (the MM part).
;
; The 0x34MM Module Census response packet consists of 8 bytes. Unused
; bits will be 0.  The module uses the following bits in the packet.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-6       Module Mode
;     0.5-0       Module Address
;     1.7-0       DEBUG RAM Checksum MsByte    DEBUG
;     2.7-0       DEBUG RAM Checksum LsByte    DEBUG
;     3.7-0       DEBUG FLASH Checksum MsByte  DEBUG
;     4.7-0       DEBUG FLASH Checksum LsByte  DEBUG
;     5.7-0       DEBUG EEPROM Checksum MsByte DEBUG
;     6.7-0       DEBUG EEPROM Checksum LsByte DEBUG
;     7.7-4       Widget Firmware Version (Major revision nbr)
;     7.3-0       Widget Firmware Version (Minor revision nbr)
;  ------------  -------------------------------------------------------
;
;
; --------------------------------------------------------------------------
; 0x18MM Module Read Counters  [1-byte payload]
; --------------------------------------------------------------------------
; This message is used to retrieve health and status counters from a CAN
; Widget.  This is intended for use by control device while on the ground
; during verification of CAN Widget behavior.  A control device sends one
; of these packets to the CAN Widget under test.  The Widget will respond
; with a 0x38MM Read Counters response packet.
;
; Under nornal use a 0x00 payload byte instructs the Widget to clear its
; counters immediately after reporting them.  However, a 0x01 payload may
; be sent if it is desired that the counters not be cleared.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7         1=Copy BootFlash (FM1) into EEPROM,0=No Copy
;     0.6-1       Reserved (0's)
;     0.0         Control: 0=reset counters, 1=don't reset after read
;  ------------  -------------------------------------------------------
;
;  NOTE: after this code was implemented it was discovered that there
;        is NO support for reading the BOOT FLASH region of memory.
;        The pattern read-back is as if no device is responding at the
;        memory addresses.
;
; --------------------------------------------------------------------------
; 0x38MM Module Read Counters Response  [8-byte payload]
; --------------------------------------------------------------------------
; A Widget constructs and sends one of these packets whenever it receives a
; 0x18MM Module Read Counters packet.  The widget must retrieve the clear
; control info from the payload of the packet and either clear the counters,
; or not, according to the payload contents.  The clear occurs AFTER
; replying to this request.
;
; The 0x38MM Module Read Counters Response packet consists of 8 bytes. Unused
; bits will be 0.  The module uses the following bits in the packet.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       CANTEC value (transmit error counter - CAN ctlr)
;     1.7-0       CANREC value (receive error counter - CAN ctlr)
;     2.7-4       Nbr packets rcvd w/CANSTCH:DLCW set since last clear
;     2.3-0       Nbr packets rcvd w/CANSTCH:BERR set since last clear
;     3.7-4       Nbr packets rcvd w/CANSTCH:SERR set since last clear
;     3.3-0       Nbr packets rcvd w/CANSTCH:CERR set since last clear
;     4.7-4       Nbr packets rcvd w/CANSTCH:FERR set since last clear
;     4.3-0       Nbr packets rcvd w/CANSTCH:AERR set since last clear
;     5.7-4       Nbr packets rcvd w/CANGSTA:BOFF set since last clear
;     5.3-0       Nbr packets rcvd w/CANGSTA:ERRP set since last clear
;     6.7-0       Reserved (0's)
;     7.7-0       Nbr of WatchDog fires since last clear
;  ------------  -------------------------------------------------------
;
;  NOTE: see [0x18MM payload0 bit0] which is set to 1 to clear counters.
;
;  NOTE2: the four bit counters are actually 8-bit counters. The values
;  shown in this payload are capped at 4 bits so values of 0x00 to 0x0E
;  are accurate. However, 0x0F indicates 15 or more events have happened.
;
;
; --------------------------------------------------------------------------
; 0x1CMM Module Jump to ISP Loader  [2-byte payload]
; --------------------------------------------------------------------------
; This message is used to command a specified CAN Widget to enter In System
; Programming (ISP) mode wherein it can receive new firmware.  Only one CAN
; Widget will enter programming mode. The other CAN Widgets will effectively
; remove themselves from the CAN bus so as to not interfere with the
; following ISP traffic on the bus.
;
; All CAN Widgets will disable power at their 40 pin Module connector and
; then reply by sending the 0x3cMM Module Jump to ISP Response message
; indicating that they are taking appropriate action.
;
; The CAN Widget which is specifically addressed in the message id will
; (after removing Module power and replying) jump immediately into the
; ATMEL ISP boot loader code effectively reconfiguring the device for
; CAN ISP messages at 500Khz bit rate ready to respond to ATMEL CAN ISP
; traffic.
;
; The remaining CAN Widgets which are NOT specifically addressed by the
; message id will (after removing Module power and replying) simply
; shut down to be awakened again only by removal and re-application of
; power to the devices via the D15P CAN bus connector.
;
; This mechanism allows a single command to be sent which will effectively
; reconfigure the CAN bus to appear as a single CAN Widget running in
; ATMEL CAN ISP mode. Therefore, we no longer have to recable the CAN
; Widgets in order to perform in-system programming. We simply send the
; command, reprogram the device, verify the device, and then remove and
; reapply power to the CAN bus resetting all CAN Widgets back into normal
; flight mode operation at 800Khz bit rate.
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-0       Fixed value of 0xF0
;     1.7-0       Fixed value of 0x0D
;  ------------  -------------------------------------------------------
;
;    The entire purpose of this payload is to severely decrease the 
;    likelyhood that this packet can be received accidentally.  With
;    this payload we added 16 more bits to this packet which must 
;    contain this fixed value.
;
;
; --------------------------------------------------------------------------
; 0x3cMM Module Jump to ISP Loader ACK  [1-byte payload]
; --------------------------------------------------------------------------
; A CAN Widget constructs and sends one of these packets whenever it
; receives a 0x1CMM Module Jump to ISP Loader packet.  Just before sending
; this reply message it removes power from the 40 pin Module connector.
;
; A CAN Widget which receives the 0x1CMM packet and whose address appears
; in the message id will then jump into the ATMEL CAN ISP firmware.
; (It will signal this by setting byte0 of the payload to 0x01)
;
; A CAN Widget which receives the 0x1CMM packet but is not addressed by
; it will go into passive mode on the bus (disable the CAN Controller
; and halt.)
; (It will signal this by setting byte0 of the payload to 0x00)
;
;  Message Bits   Purpose
;  ------------  -------------------------------------------------------
;     0.7-1       Reserved (0's)
;     0.0         Action: 0=HALTing, 1=JUMPing to ISP Bootloader
;  ------------  -------------------------------------------------------
;
;
; --------------------------------------------------------------------------
;
;  Now... the CAN code...
;
;  How about some STREAM names?
;    NOTE: these values are shifted left two bits in order to facilitate
;          comparison and masking with the device registers containing the
;          STREAM values.
;  so...  xxSSSSxx is the value which also corresponds to the table at
;  the top of this canio file.
;
.equ    LOW_PRI_MSG,0x40    ; this bit set with stream id means low priority data xfer

.equ    MOD_CONFIG,0x00     ; 0  0  0  0 - 0x00MM Module Configure Command
.equ    MOD_BYTES,0x04+LOW_PRI_MSG ; 0  0  0  1 - 0x04MM Byte-pipe data to write to Module

.equ    MOD_TEST,0x10   ; 0  1  0  0 - 0x10MM Module TEST
.equ    MOD_CENSUS,0x14     ; 0  1  0  1 - 0x14MM Module Census Query (Broadcast)
.equ    MOD_GET_CTRS,0x18   ; 0  1  1  0 - 0x18MM Module Read Counters
.equ    MOD_JMP2ISP,0x1C    ; 0  1  1  1 - 0x1CMM Module Jump to ISP Loader

.equ    RPL_IN08,0x20       ; 1  0  0  0 - 0x20MM Module Status IN08 (mux mode)
.equ    RPL_AN03,0x24       ; 1  0  0  1 - 0x24MM Module Status AN03 (w/IN03, standard mode)
.equ    RPL_AN47,0x28       ; 1  0  1  0 - 0x28MM Module Status AN47 (w/IN47, standard mode)
.equ    RPL_BYTES,0x2C+LOW_PRI_MSG ; 1  0  1  1 - 0x2CMM Byte-pipe data read fm Module

.equ    RPL_CENSUS,0x34     ; 1  1  0  1 - 0x14MM Module Census Query (Broadcast)
.equ    RPL_GET_CTRS,0x38   ; 1  1  1  0 - 0x14MM Module Read Counters
.equ    RPL_JMP2ISP,0x3C    ; 1  1  1  1 - 0x14MM Module Jump to ISP Loader

; Control values for CAN device
.equ    CAN_ENA, 0x02       ; enable CAN controller
.equ    CAN_GRST, 0x01      ; globally reset CAN controller

; Frequently used mask values (msg rx filters)
;   match on STREAM only
.equ    MSK_STRM_M1,0xf8
.equ    MSK_STRM_M2,0x00
;   match on ADDRESS only
.equ    MSK_ADDR_M1,0x07
.equ    MSK_ADDR_M2,0xe0
;   match on both STREAM and ADDRESS
.equ    MSK_STAD_M1,0xff
.equ    MSK_STAD_M2,0xe0

; constants for page clearing and setting
.equ    CTL_RBUF8BYTE, 0xc8

.equ    CTL_RX8BYTE, 0x88
.equ    CTL_RX2BYTE, 0x82
.equ    CTL_RX1BYTE, 0x81
.equ    CTL_RX0BYTE, 0x80

.equ    CTL_TX8BYTE, 0x48
.equ    CTL_TX0BYTE, 0x40

.equ    CTL_DISABLE, 0x00

; message objects (page select values + 0 payload index value)
.equ    PAG_0, 0x00     ; census-request object
.equ    PAG_1, 0x10     ; transmit object
.equ    PAG_2, 0x20     ; TEST
.equ    PAG_3, 0x30     ; configure-request object
.equ    PAG_4, 0x40     ; write bytes to Module request
.equ    PAG_5, 0x50     ;
.equ    PAG_6, 0x60     ; get-counters-request object
.equ    PAG_7, 0x70     ; jump-to-ISP-request object
.equ    PAG_8, 0x80
.equ    PAG_9, 0x90
.equ    PAG_A, 0xa0
.equ    PAG_B, 0xb0
.equ    PAG_C, 0xc0
.equ    PAG_D, 0xd0
.equ    PAG_E, 0xe0

; enable bits for CAN interrupts based on active MsgObjs
.equ    ENA_IE1, 0x00
.equ    ENA_IE2, 0xDF
.equ    DSA_IEx, 0x00

; --------------------------------------------------------------------------
; init_cenrqst() - setup a Census broadcast receiver message object
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_cenrqst:
    mov     r5,#MOD_CENSUS  ; set our STREAM Id
    mov     r4,#0x00        ; set NO dvc ADDRESS (It's a broadcast)
    lcall   strmad2id       ; convert dvc ADDRESS to Id bits in r6,r7
    mov     CANPAGE,#PAG_0  ; select page=0, reset msgReg index to 0
    mov     r2,#CTL_RX0BYTE ; setup: enable non-buffered receive, NO payload
    acall   initstrmpg      ; setup page for rx w/match of STREAM only
    mov     CANPAGE,#PAG_0  ; Let's leave zero (broadcast-rcvr-page selected)
    ret ; return to caller

; --------------------------------------------------------------------------
; init_tstrqst() - setup a TEST broadcast receiver message object
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_tstrqst:
    mov     r5,#MOD_TEST    ; set our STREAM Id
    mov     r4,#0x00        ; set NO dvc ADDRESS (It's a broadcast)
    lcall   strmad2id       ; convert dvc ADDRESS to Id bits in r6,r7
    mov     CANPAGE,#PAG_2  ; select page=2, reset msgReg index to 0
    mov     r2,#CTL_RX0BYTE ; setup: enable non-buffered receive, NO payload
    acall   initstrmpg      ; setup page for rx w/match of STREAM only
    mov     CANPAGE,#PAG_0  ; Let's leave zero (broadcast-rcvr-page selected)
    ret ; return to caller

; --------------------------------------------------------------------------
; init_isprqst() - setup a ISP rqst broadcast receiver message object
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_isprqst:
    mov     r5,#MOD_JMP2ISP ; set our STREAM Id
    mov     r4,#0x00        ; set NO dvc ADDRESS (It's a broadcast)
    lcall   strmad2id       ; convert ADDRESS to Id bits in r6,r7
    mov     CANPAGE,#PAG_7  ; select page=7, reset msgReg index to 0
    mov     r2,#CTL_RX2BYTE ; setup: enable non-buffered receive, 2-Byte payload
    acall   initstrmpg      ; setup page for rx w/match of STREAM only
    mov     CANPAGE,#PAG_0  ; Let's leave zero (broadcast-rcvr-page selected)
    ret ; return to caller

; --------------------------------------------------------------------------
; initstadpg() - setup currently selected msssage object according to curr reg values
;  This sets up an object to receive but match both STREAM and ADDRESS
; INPUTS:
;   r6 - CANIDT1  init value
;   r7 - CANIDT2  init value
;   r2 - CANCONCH init value
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r0,r1 are destroyed
;   message object is enabled for receive (buffered or unbuffered as requested)
initstadpg:
    mov     CANIDM1,#MSK_STAD_M1    ; these bits must match (STREAM and ADDRESS)
    mov     CANIDM2,#MSK_STAD_M2    ; don't care about these
    sjmp    initpage            ; do rest of setup

; --------------------------------------------------------------------------
; initstrmpg() - setup currently selected msssage object according to curr reg values
;  This sets up an object to receive but match STREAM and ignore ADDRESS
; INPUTS:
;   r6 - CANIDT1  init value
;   r7 - CANIDT2  init value
;   r2 - CANCONCH init value
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r0,r1 are destroyed
;   message object is enabled for receive (buffered or unbuffered as requested)
initstrmpg:
    mov     CANIDM1,#MSK_STRM_M1    ; these bits must match (STREAM only)
    mov     CANIDM2,#MSK_STRM_M2    ; don't care about these
initpage:
    clr     a
    mov     CANSTCH,a       ; clear status for page
    mov     CANCONCH,a      ; clear control for page
    mov     CANIDT1,r6      ; set calculated IDT1 value
    mov     CANIDT2,r7      ; set calculated IDT2 value
;   mov     CANIDT3,a       ; (but NO BITS HERE for 2.0A)
    mov     CANIDT4,a       ; clear RTR, RB0
;   mov     CANIDM3,a       ; ditto (but NO BITS HERE for 2.0A)
    mov     CANIDM4,#0x05   ; make sure we don't see when RTR or RB0 set
    mov     CANCONCH,r2     ; set payload len and buffering
    ret ; return to caller

; --------------------------------------------------------------------------
; init_ctrsrqst() - setup a get-counters receiver message object
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_ctrsrqst:
    mov     r5,#MOD_GET_CTRS    ; set our MESSAGE to 'MOD_GET_CTRS'
    mov     r4,mod_addr         ; set our ADDRESS for this widget
    lcall   strmad2id           ; convert ADDRESS to ID bits in r6,r7
    mov     CANPAGE,#PAG_6      ; select page=6, reset msgReg index to 0
    mov     r2,#CTL_RX1BYTE     ; setup: enable non-buffered receive, 1 byte payload
    lcall   initstadpg          ; setup page for rx w/match of STREAM & ADDRESS
    mov     CANPAGE,#PAG_0      ; Let's leave zero (broadcast-rcvr-page selected)
    ret ; return to caller

; --------------------------------------------------------------------------
; init_piperqst() - setup a Byte-pipe write-bytes-o-module request
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_piperqst:
    mov     r5,#MOD_BYTES   ; set our STREAM Id
    mov     r4,mod_addr     ; set our ADDRESS for this widget
    lcall   strmad2id       ; convert ADDRESS to ID bits in r6,r7
    mov     CANPAGE,#PAG_4  ; select page=4, reset msgReg index to 0
    mov     r2,#CTL_RX8BYTE ; setup: enable non-buffered receive, 8 byte payload
    lcall   initstadpg      ; setup page for rx w/match of STREAM & ADDRESS
    mov     CANPAGE,#PAG_0  ; Let's leave zero (configure-rcvr) page selected
    ret ; return to caller

; --------------------------------------------------------------------------
; init_cfgrqst() - setup a receiver message object to pick messages to this ADDRESS only
;  being sure to enable interrupts so that the interrupt regs can be
;  polled to determine when one of these is heard
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   A Message Object is configured, enabled and ready to receive CAN messages
;   r7-r4 and r2 are destroyed
init_cfgrqst:
    mov     r5,#MOD_CONFIG  ; select our configure message
    mov     r4,mod_addr     ; get our ADDRESS for this widget
    lcall   strmad2id       ; convert ADDRESS to ID bits in r6,r7
    mov     CANPAGE,#PAG_3  ; select page=3, reset msgReg index to 0
    mov     r2,#CTL_RX2BYTE ; stdMode: enable non-buffered receive, 2 byte payload
    jnb     MUX_MODE,inicfg2
    mov     r2,#CTL_RX8BYTE ; muxMode: enable non-buffered receive, 8 byte payload
inicfg2:
    lcall   initstadpg          ; setup page for rx w/match of STREAM & ADDRESS
    mov     CANPAGE,#PAG_0  ; Let's leave zero (broadcast-rcvr-page selected)
    ret ; return to caller

; --------------------------------------------------------------------------
; read_cenrqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_cenrqst:
    mov     a,#PAG_0    ; select page=0, reset msgReg index to 0
    mov     r2,#payload0    ; deposit received bytes in payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_tstrqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_tstrqst:
    mov     a,#PAG_2    ; select page=2, reset msgReg index to 0
    mov     r2,#payload0    ; deposit received bytes in payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_cfgrqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_cfgrqst:
    mov     a,#PAG_3    ; select page=3, reset msgReg index to 0
    mov     r2,#payload0    ; deposit received bytes in payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_piperqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_piperqst:
    mov     a,#PAG_4    ; select page=4, reset msgReg index to 0
    mov     r2,#pipeout_payload ; deposit received bytes in pipe-specific payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_ctrsrqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_ctrsrqst:
    mov     a,#PAG_6    ; select page=6, reset msgReg index to 0
    mov     r2,#payload0    ; deposit received bytes in payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_isprqst() - capture info into r7,r6,r5,r4,r3 and RAM payload[0-7]
; INPUTS:
;   None
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7])
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   acc is destroyed
read_isprqst:
    mov     a,#PAG_7    ; select page=7, reset msgReg index to 0
    mov     r2,#payload0    ; deposit received bytes in payload[0-7]
    sjmp    read_rxmsg

; --------------------------------------------------------------------------
; read_rxmsg() - capture received message details to RAM and registers
; INPUTS:
;   acc - CAN PAGE to read
; OUTPUTS:
;   r7 - CANIDT2
;   r6 - CANIDT1
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload length (number of valid bytes in RAM payload[0-7]
;   r2 - payload address in RAM
; SIDE-EFFECTS:
;   payload bytes stored in RAM (payload[0-7])
;   if payload is less than 8 bytes, unused bytes are left at previous value
;   CAN device page system is undisturbed
;    (left pointing to page it was before this routine ran)
read_rxmsg:
    ; save context
    push    acc         ; save acc
    xch     a,b
    push    acc         ; save b
    mov     a,b
    mov     b,CANPAGE   ; save current page
    ; process incoming message
    mov     CANPAGE,a   ; select desired page, reset msgReg index to 0
    lcall   ct_errors   ; update ctrs tracking errors
    mov     r6,CANIDT1  ; get id10-id03
    mov     a,CANIDT2   ; get id02-id00
    anl     a,#0xE0     ; mask off indeterminate bits
    mov     r7,a        ; move cleaned up value to r7
    lcall   id2strmad   ; setup r4,r5 w/STREAM, dvc ADDRESS
    lcall   payload2ram ; read payload bytes into RAM
    ; restore context
    mov     CANPAGE,b   ; restore back to current page
    pop     acc         ; restore b
    mov     b,a
    pop     acc         ; restore acc
    ret ; return to caller

; --------------------------------------------------------------------------
; ct_errors() - count errors indicated by global and channel status regs
; INPUTS:
;   CAN status regs CANGSTA and CANSTCH
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc is destroyed
;   counters in RAM are updated
ct_errors:
    clr     BADCANRX        ; reset pkt unusable flag
    ; check CAN Global Status
    mov     a,CANGSTA       ; count general status errors
    jnb     acc.1,no_boff
    inc     ctr_can_boff
no_boff:
    jnb     acc.0,no_errp
    inc     ctr_can_errp
no_errp:
    ; check CAN Channel Status
    mov     a,CANSTCH       ; count msg-object-specific errors
    jnb     acc.7,no_dlcw
    setb    BADCANRX        ; packet is unusable
    inc     ctr_wrong_pkt
no_dlcw:
    jnb     acc.4,no_berr
    inc     ctr_can_berr
no_berr:
    jnb     acc.3,no_serr
    setb    BADCANRX        ; packet is unusable
    inc     ctr_can_serr
no_serr:
    jnb     acc.2,no_cerr
    setb    BADCANRX        ; packet is unusable
    inc     ctr_can_cerr
no_cerr:
    jnb     acc.1,no_ferr
    setb    BADCANRX        ; packet is unusable
    inc     ctr_can_ferr
no_ferr:
    jnb     acc.0,no_aerr
    setb    BADCANRX        ; packet is unusable
    inc     ctr_can_aerr
no_aerr:
    jnb     BADCANRX,cte_exit
    clr     OUT7        ; (TST) Strobe: CAN received err'd msg
    setb    OUT7
    clr     OUT7
    setb    OUT7
cte_exit:
    ret ; return to caller

; --------------------------------------------------------------------------
; clr_ctrs() - clear all simulated event counters
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   counters in RAM are zero'd
clr_ctrs:
    ; save context
    push    acc             ; save user ACC
    mov     a,r2            ; save user R2
    push    acc
    mov     a,r1            ; save user R1
    push    acc
    ; zero our counter memory
    mov     r1,#ctr_base    ; get address of lowest ctr
    mov     r2,#ctr_bytes   ; get number of bytes ctr's occupy
    clr     a
clr_lp:
    mov     @r1,a           ; zero out this counter
    inc     r1              ; point to next counter
    djnz    r2,clr_lp       ;  do so until all counters zeroed
    ; restore context
    pop     acc
    mov     r1,a            ; restore user R1
    pop     acc
    mov     r2,a            ; restore user R2
    pop     acc             ; restore user ACC
    ret ; return to caller

; --------------------------------------------------------------------------
; payload2ram() - a message with a nonzero length payload was received, and
;  is sitting in the CAN Macro registers/ram. Copy payload bytes to RAM out
;  of the CAN device.
; INPUTS:
;   r2 - address of byte array to receive payload byte(s)
; OUTPUTS:
;   r3 - number of bytes received (capped at 8)
; SIDE-EFFECTS:
;   acc is destroyed
;   payload bytes now in RAM @r2[0-7] iff r3 > 0
;  NOTE: unused bytes in payload are NOT cleared
payload2ram:
    ; get only DLC bits and copy to r3
    mov     a,CANCONCH  ; read msg obj config and DLC
    anl     a,#0x0f     ; isolate DLC bits
    mov     r3,a        ; r3 = DLC
    jz      nopayload   ; Hrm... no payload so we are done
    ; preserve context
    mov     a,r0
    push    acc         ; save r0
    mov     a,r2
    push    acc         ; save r2
    mov     a,r3
    ; limit incoming payload to 8 bytes, MAX
    cjne    a, #9, chk8 ; set CY flg if acc < 9
chk8:
    jc      chk8ex      ; skip next if acc 8 or less
    mov     a, #8       ; >8 so override with 8
    mov     r3,a        ; and return this override as well...
chk8ex:
    ; end of limit check....
    xch     a,r2            ; LEN->r2, ADDR->acc
    xch     a,r0            ; ADDR->r0, Garbage->acc
getpaybyte:
    mov     @r0,CANMSG      ; save payload byte to RAM
    inc     r0              ; point to next RAM locn
    djnz    r2,getpaybyte   ; if not done, go do again...
    ; restore context
    pop     acc         ; restore r2
    mov     r2,a
    pop     acc         ; restore r0
    mov     r0,a
nopayload:
    ret ; return to caller

; --------------------------------------------------------------------------
; clr_cenrqst() - re-enable broadcast listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_cenrqst:
    mov     a,#PAG_0
    mov     r2,#CTL_RX0BYTE
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_tstrqst() - re-enable broadcast listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_tstrqst:
    mov     a,#PAG_2
    mov     r2,#CTL_RX0BYTE
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_txok() - reset transmit object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_txok:
    mov     a,#PAG_1
    mov     r2,#CTL_DISABLE
    setb    CANXMTIDLE  ; mark our transmitter as IDLE
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_cfgrqst() - re-enable device-specific listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_cfgrqst:
    mov     a,#PAG_3
    mov     r2,#CTL_RX2BYTE ; stdMode: enable non-buffered receive, 2 byte payload
    jnb     MUX_MODE,clrcfg2
    mov     r2,#CTL_RX8BYTE ; muxMode: enable non-buffered receive, 8 byte payload
clrcfg2:
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_piperqst() - re-enable byte-pipe listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_piperqst:
    mov     a,#PAG_4
    mov     r2,#CTL_RX8BYTE
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_ctrsrqst() - re-enable device-specific listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_ctrsrqst:
    mov     a,#PAG_6
    mov     r2,#CTL_RX1BYTE
    sjmp    reset_page

; --------------------------------------------------------------------------
; clr_isprqst() - re-enable device-specific listener object
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc,r2 destroyed
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
clr_isprqst:
    mov     a,#PAG_7
    mov     r2,#CTL_RX2BYTE
    sjmp    reset_page

; --------------------------------------------------------------------------
; reset_page() - clear page status and reset page control
; INPUTS:
;   acc - Msg Obj Nbr (PAGE)
;   r2  - desired page control value
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
reset_page:
    ; save context
    xch     a,r1        ; preserve r1
    push    acc
    mov     a,CANPAGE   ; get curr page
    xch     a,r1        ; save in r1, get desired page in a
    ; reset message object
    mov     CANPAGE,a   ; set desired page
    mov     CANSTCH,#0  ; clear status
    mov     CANCONCH,r2 ; configure page
    ; restore context
    xch     a,r1        ; retrieve saved curr page
    mov     CANPAGE,a   ; reset to curr page
    pop     acc         ; restore r1
    xch     a,r1
    ret ; return to caller

; --------------------------------------------------------------------------
;    sho_tx_err() - for now, unexpected errors show up on serial output
;  USED DURING TESTING
; INPUTS:
;   acc - Msg Obj Nbr (PAGE)
;   r2  - desired page control value
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Message Object is reconfigured, status is cleared
;   Current page (at entry) is active at exit
sho_tx_err:
    ljmp    p1x_exit

; --------------------------------------------------------------------------
; waitx1cmplt() - about to send another CAN message, wait until prior send
;                 has completed
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   acc  is destroyed
;   if xmitter hasn't finished it loops forever... until xmitter finishes
waitx1cmplt:
    ; LOOP FOREVER (iff bus problem/device breaks)
    mov     diag_loopid,#LPID_TX1CMPLT  ; LOOP:wtg for CAN TX1 Cmplt
waitx1cmlp:
    mov     a,CANSTCH         ; get status for this page
    jnb     acc.6,waitx1cmlp  ; loop until previous xmit is complete
    clr     diag_loopid       ; show that we are no longer in a tight-loop
    setb    CANXMTIDLE        ;  now mark transmitter as IDLE...
    ret ; return to caller

; --------------------------------------------------------------------------
; page1xmit() - send a CAN message using message object 1
;   NOTE: load r0 and use alternate entry of page1xmpay to send from diff
;         payload array.
; INPUTS:
;   r5 - STREAM [0-f]
;   r4 - device ADDRESS - [00-3f]
;   r3 - payload len
;   payload, if any, in RAM at @r0: typically payload[0-7]
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys r0
;   if xmitter hasn't finished last one, it waits before starting this one...
.equ    CANSTCH_TXOK, 0x40
;
page1xmit:
    mov     r0,#payload0    ; get address of payload

page1xmpay:
    clr     OUT7        ; (TST) Strobe: send CAN Msg
    setb    OUT7
    lcall   strmad2id       ; convert ADDRESS to ID bits in r6,r7
    push    acc             ; save user ACC
    mov     a,r3            ; save user R3
    push    acc
    mov     CANPAGE,#PAG_1  ; select page=1, reset msgReg index to 0
    jb      INCANISR,skipEAwrap ; while in CAN-ISR, must poll H/W
    jnb     EA,nonINTR      ; if CAN in polled mode, go...
    ; here if CAN run in interrupt mode (non-polled)
INTRwaitCAN:
    jb      CANXMTIDLE,p1x_send ; no xmit in progress, go
    ; xmit is in progress, we must wait for ISR to end it
    sjmp    INTRwaitCAN     ; simply spin on this bit until ISR clears it
nonINTR:
skipEAwrap:
    jb      CANXMTIDLE,p1x_send ; no xmit in progress, go without waiting
    ; wait for prior xmit to complete
    lcall   waitx1cmplt
    cjne    a,#CANSTCH_TXOK,sho_tx_err  ; eeee -> TODO???  if prior transmit error'd, skip this one?

p1x_send:   ; now send this message
    clr     CANXMTIDLE      ; MARK CAN transmitter as ACTIVE!!!
    mov     CANSTCH,#0x00   ; clear status, page 1
;   mov     CANCONCH,#0x00  ; (not needed?) disable page 1
    ; set message ID
    mov     CANIDT2,r7      ; set 3 LSBits of identifier
    mov     CANIDT1,r6      ; set top 8-bits of identifier
    mov     CANIDT4,#0      ; clear RTR, RB0
    mov     a,r3
    jz      p1x_sendit
    ; if r3 != 0 then copy payload bytes to register-set
p1x_cppayld:
    mov     CANMSG,@r0      ; write byte to register
    inc     r0              ; point next byte
    djnz    r3,p1x_cppayld      ; do another, if not done
p1x_sendit:
    ; using original value of r3 already in a...
    orl     a,#0x40         ; or-in control bit
    mov     CANCONCH,a      ; start transmission, IDE=0, DLC=R3
    ; done setting up for send.  Let CAN device do it...
p1x_exit:
    pop     acc             ; restore user R3
    mov     r3,a
    pop     acc             ; restore user ACC
    ret ; return to caller

; --------------------------------------------------------------------------
; id2strmad() - convert CANIDTx register loads to STREAM:ADDRESS
; INPUTS:
;   r6 - CANIDT1       [PSSSSMMM] (ID10-ID3)
;   r7 - CANIDT2       [LLLxxxxx]  (ID2-ID0)
; OUTPUTS:
;   r4 - device ADDRESS - [00-3f] (00MMMLLL)
;   r5 - STREAM           [00-3c] (00SSSS00)
; SIDE-EFFECTS:
;   None
id2strmad:
    ; save context
    push    acc     ; save acc
    mov     a,b     ; save b
    push    acc
    ; calculate our message ID: LS-3 bits
    mov     a,r7    ; get (LLLxxxxx)
    rl      a
    rl      a
    rl      a       ; now (xxxxxLLL)
    anl     a,#0x07 ; now (00000LLL)
    mov     r4,a    ; hold in r4
    mov     a,r6    ; get (PSSSSMMM)
    rl      a
    rl      a
    rl      a       ; now (SSMMMPSS)
    anl     a,#0x38 ; now (00MMM000)
    orl     a,r4    ; now (00MMMLLL)
    mov     r4,a    ; r4 now equals dvc ADDRESS
    mov     a,r6    ; get (PSSSSMMM) again
    rr      a       ; now (MPSSSSMM)
    anl     a,#0x7c ; now (0PSSSS00)
    mov     r5,a    ; r5 now equals STREAM id
    ; restore context
    pop     acc     ; restore b
    mov     b,a
    pop     acc     ; restore acc
    ret ; return to caller

; --------------------------------------------------------------------------
; strmad2id() - convert STREAM:ADDRESS to CANIDTx register loads
; INPUTS:
;   r4 - device ADDRESS - [00-3f] (00MMMLLL)
;   r5 - STREAM            [0-3c] (00SSSS00)
; OUTPUTS:
;   r6 - CANIDT1       [PSSSSMMM] (ID10-ID3)
;   r7 - CANIDT2       [LLLxxxxx] (ID2-ID0)
; SIDE-EFFECTS:
;   None
strmad2id:
    ; save context
    push    acc     ; save acc
    mov     b,a     ; save b
    push    acc
    ; calculate our message ID: LS-3 bits
    mov     a,r4    ; get device ADDRESS (xxMMMLLL)
    anl     a,#0x3f ; make sure only device ADDRESS (00MMMLLL)
    rr      a       ; move 3-lsbits to ms & 3-msbits to ls: (LLL00MMM)
    rr      a
    rr      a
    push    acc     ; save (LLL00MMM)
    anl     a,#0xe0 ; now:  (LLL00000)
    mov     r7,a    ; set 3 LSBits of identifier [LLLxxxxx]
    pop     acc     ; retrieve (LLL00MMM)
    anl     a,#0x07 ; now: (00000MMM)
    mov     b,a     ; move work in process to b (00000MMM)
    ; calculate our message ID: MS-8 bits
    mov     a,r5    ; get (xPSSSSxx)
    anl     a,#0x7c ; now: (0PSSSS00)
    rl      a       ; now: (PSSSS000)
    orl     a,b     ; now: (PSSSSMMM)
    mov     r6,a    ; set top 8-bits of identifier [PSSSSMMM]
    ; restore context
    pop     acc     ; restore b
    mov     b,a
    pop     acc
    ret     ; return to caller

; --------------------------------------------------------------------------
; init_can() - Initialize the CAN controller in CAN Module we have an 8Mhz CPU
; clock and desire an 800kHz CAN bit rate so setup as follows:
;   for 800kHz@8Mhz we have 10TQ (1TQ=125nSec.) & 3 sample points at 70% into
;   bit.  Tsjw says we can adjust up to 1 bit times when we resync
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys acc,r0-r3,r6,r7
;   CAN device is configured for the desired bus speed and has indicated
;   that it is ready for use
;
init_can:
    mov     r1,#0x00        ; CANBT1 set BRP=1
    mov     r2,#0x04        ; CANBT2 set Tsjw=1, Tprs=3
    mov     r3,#0x25        ; CANBT3 set Tphs2=3, Tphs1=3, Samp=1
; SPECIAL ENTRY POINT:
;     Initialize the CAN controller w/R1-R3 provided by caller
;           (Used by PhyTec test jig setup)
docaninit:
    lcall   clr_ctrs        ; reset the CAN status counters
    lcall   reset_can       ; reset the controller
    ; setup clocks/timing
    mov     CANBT1,r1       ; set BRP
    mov     CANBT2,r2       ; set Tsjw, Tprs
    mov     CANBT3,r3       ; set Tphs2, Tphs1, Samp
    mov     CANGIT,#0       ; clear current interrupt reports, if any
    ; enable device
    mov     CANGCON,#CAN_ENA ; set device to ENABLE
    ; enable all CAN-chip-internal interrupt reporting
    mov     CANIE1,#0x7f    ; enable interrupt from all pages
    mov     CANIE2,#0xff    ; enable interrupt from all pages
    orl     CANGIE,#0x3f    ; enable all interrupt reporting within CAN chip
    ; wait for device to come alive
waitena:
    mov     diag_loopid,#LPID_CANENA  ; LOOP:wtg for CAN to say ENABLED
waitenalp:
    ; LOOP FOREVER (iff device breaks)
    mov     a,CANGSTA       ; does controller say it's alive?
    jnb     acc.2,waitenalp ; no- go check again
    clr     diag_loopid     ; show that we are no longer in a tight-loop
    ret         ; return to caller

; --------------------------------------------------------------------------
; reset_can() - reset the controller, taking it off the CAN bus. Leave it reset
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys acc,r0,r6,r7
reset_can:
    mov     CANGCON,#CAN_GRST ; reset the CAN chip
    clr     ECAN        ; diable CAN interrupt
    clr     ETIM        ; disable CAN timer-overflow interrupt
; wait for device to go dead
waitdsa:
    mov     a,CANGSTA
    jb      acc.2,waitdsa
; continue clearing of CAN regs
    setb    CANXMTIDLE  ; MARK are transmitter as IDLE (we're not sending right now...)
    mov     r7,#15      ; 15 pages, numbered 0-14
    clr     acc     ; set page = 0
    mov     r0,a        ; save zero to r0
clr_page:
    mov     CANPAGE,a   ; select page (is incremented below)
    mov     CANCONCH,r0 ; clear controls for this page
    mov     CANSTCH,r0
    mov     CANIDT1,r0
    mov     CANIDT2,r0
    mov     CANIDT3,r0
    mov     CANIDT4,r0
    mov     CANIDM1,r0
    mov     CANIDM2,r0
    mov     CANIDM3,r0
    mov     CANIDM4,r0
    mov     r6,#8       ; reset to 8 message bytes to clear
clr_byt:
    mov     CANMSG,r0   ; clear data bytes for this page
    djnz    r6,clr_byt
    add     a,#0x10     ; page = page + 1
    djnz    r7,clr_page
    ret       ; return to caller

; --------------------------------------------------------------------------
; sho_canregs() - display full set of CAN registers to serial OUT
;  USED DURING TESTING
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys current DPTR
;   clears the general interrupt bits (CANGIT)
sho_canregs:
    push    acc
    mov     a,CANGIT
    anl     a,#0xff-0x40    ; kill unused bits
sho_cantoo:
sho_canexit:
    jz      noclrgit
    anl     CANGIT,#0xc0    ; clear all interrupt bits
noclrgit:
    pop     acc
    ret ; return to caller

;
;  End of CAN I/O Routines
; --------------------------------------------------------------------------
; -------------------------------------------------------------------------
; AMSAT Module CAN Interface - Utility Routines
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: utils.a51,v 1.11 2004/09/29 07:49:31 stephen Exp $
; -------------------------------------------------------------------------
;
.org    code_page2  ; our utility routines live on this page

; --------------------------------------------------------------------------
; dptr_2compl() - perform 2's complement of DPTR (in place)
;  INPUTS:
;   DPTR has value to be complemented
;  OUTPUTS:
;   DPTR is now 0-DPTR
;  SIDE-EFFECTS:
;   PSW.CY is set if DPTR underflows
;   1 byte is pushed on stack then removed in order to preserve acc
dptr_2compl:
    push    acc         ; save acc
    clr     c           ; start with no CY
    clr     a           ; get a zero
    subb    a,dpl       ; subtract DPL from zero
    mov     dpl,a       ; save lsByte complement
    clr     a           ; get a zero
    subb    a,dph       ; subtract DPH + CY from zero
    mov     dph,a       ; save msByte of complement
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; div_dptr_by16() - divide 16bit value in DPTR by 16
; div_dptr_by4()  - divide 16bit value in DPTR by 4
; div_dptr_by2()  - divide 16bit value in DPTR by 2
;  INPUTS:
;   DPTR - value to be divided
;  OUTPUTS:
;   DPTR is now DPTR / 16 or 4 or 2
;  SIDE-EFFECTS:
;   cy is destroyed
div16_dptr_by16:
    acall   div16_dptr_by4
div16_dptr_by4:
    acall   div16_dptr_by2
div16_dptr_by2:
    clr     c
    push    acc
    mov     a,dph
    rrc     a
    mov     dph,a
    mov     a,dpl
    rrc     a
    mov     dpl,a
    pop     acc
    ret

; --------------------------------------------------------------------------
; div16_ba_by16() - divide 16bit value (in b,acc) by 16
; div16_ba_by4()  - divide 16bit value (in b,acc) by 4
; div16_ba_by2()  - divide 16bit value (in b,acc) by 2
;  INPUTS:
;   b,a - value to be divided
;  OUTPUTS:
;   b,a is now b,a / 16 or 4 or 2
;  SIDE-EFFECTS:
;   cy is destroyed
div16_ba_by16:
    acall   div16_ba_by4
div16_ba_by4:
    acall   div16_ba_by2
div16_ba_by2:
    clr     c
    push    acc
    mov     a,b
    rrc     a
    mov     b,a
    pop     acc
    rrc     a
    ret

; --------------------------------------------------------------------------
; add8_dptr_a() - add acc value to DPTR
;  INPUTS:
;   DPTR - running total
;   acc  - value to be added to total
;  OUTPUTS:
;   DPTR is now DPTR + acc
;  SIDE-EFFECTS:
;   PSW.CY is set if DPTR overflows
;   1 byte is pushed on stack then removed in order to preserve acc
add8_dptr_a:
    push    acc         ; save acc
    add     a,dpl       ; add 'A' To DPL
    mov     dpl,a       ; store lsByte of result into DPL
    mov     a,dph       ; get DPH
    addc    a,#000h     ; add carryout to DPH if preset
    mov     dph,a       ; store msByte of result into DPH
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; add16_dptr_ba() - add 16bit value (in b,acc) to DPTR
;  INPUTS:
;   DPTR - running total
;   b    - msByte of value to be added to total
;   acc  - lsByte of value to be added to total
;  OUTPUTS:
;   DPTR is now DPTR + (b,acc)
;  SIDE-EFFECTS:
;   PSW.CY is set if DPTR overflows
;   1 byte is pushed on stack then removed in order to preserve acc
add16_dptr_ba:
    push    acc         ; save acc
    add     a,dpl       ; add 'A' To DPL (ignore CY)
    mov     dpl,a       ; store lsByte of result into DPL
    mov     a,dph       ; get DPH
    addc    a,b         ; add 'B' + CY To DPH
    mov     dph,a       ; store msByte of result into DPH
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; add16_r0_ba() - add 16bit value (in b,acc) to Internal RAM at r0+0 and r0+1
;  INPUTS:
;   @r0  - running total
;   b    - msByte of value to be added to total
;   acc  - lsByte of value to be added to total
;  OUTPUTS:
;   RAM 16bit word @r0 is now @r0 + (b,acc)
;  SIDE-EFFECTS:
;   PSW.CY is set if @r0 overflows
;   1 byte is pushed on stack then removed in order to preserve acc
add16_r0_ba:
    push    acc         ; save acc
    inc     r0          ; point To lsByte
    add     a,@r0       ; add lsByte from RAM to 'A' (ignore CY)
    mov     @r0,a       ; store lsByte of result back into RAM
    dec     r0          ; point To msByte
    mov     a,@r0       ; get msByte from RAM
    addc    a,b         ; add 'B' + CY To msByte
    mov     @r0,a       ; store msByte of result back into RAM
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; cmp16_r0_dptr() - compare 16bit value pointed to by R0 to contents of DPTR
;  INPUTS:
;   DPTR - compare value
;   R0   - offset into internal RAM of 16bit value to be compared
;  OUTPUTS:
;   psw.cy = 0/1 where 1 = iram[R0] > DPTR, 0 = iram[R0] <= DPTR
;  SIDE-EFFECTS:
;   psw.z and psw.p may be altered
;   1 byte is pushed on stack then removed in order to preserve acc
cmp16_r0_dptr:
    push    acc         ; save acc
    clr     c           ; start with no CY
    inc     r0          ; point To lsByte
    mov     a,@r0       ; get lsByte
    subb    a,dpl       ; subtract DPL from lsByte setting CY
    dec     r0          ; point To msByte
    mov     a,@r0       ; get msByte
    subb    a,dph       ; subtract DPH + CY from msByte setting CY
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; cmp16_r1_dptr() - compare 16bit value pointed to by R1 to contents of DPTR
;  INPUTS:
;   DPTR - compare value
;   R1   - offset into internal RAM of 16bit value to be compared
;  OUTPUTS:
;   psw.cy = 0/1 where 1 = iram[R1] > DPTR, 0 = iram[R1] <= DPTR
;  SIDE-EFFECTS:
;   psw.z and psw.p may be altered
;   1 byte is pushed on stack then removed in order to preserve acc
cmp16_r1_dptr:
    push    acc         ; save acc
    clr     c           ; start with no CY
    inc     r1          ; point To lsByte
    mov     a,@r1       ; get lsByte
    subb    a,dpl       ; subtract DPL from lsByte setting CY
    dec     r1          ; point to msByte
    mov     a,@r1       ; get msByte
    subb    a,dph       ; subtract DPH + CY from msByte setting CY
    pop     acc         ; restore acc
    ret             ; return to caller

; --------------------------------------------------------------------------
; cmp16_dptr_ba() - compare 16bit value (in b,acc) to contents of DPTR
;  INPUTS:
;   DPTR - compare value
;   b    - msByte of 16bit value to be compared
;   acc  - lsByte of 16bit value to be compared
;  OUTPUTS:
;   psw.cy = 0/1 where 1 = b,acc < DPTR, 0 = b,acc >= DPTR
;  SIDE-EFFECTS:
;   psw.z and psw.p may be altered
;   1 byte is pushed on stack then removed in order to preserve acc
cmp16_dptr_ba:
    push    acc         ; save acc
    clr     c           ; start with no CY
    subb    a,dpl       ; subtract DPL from lsByte in acc setting CY
    mov     a,b         ; get high Byte
    subb    a,dph       ; subtract DPH + CY from msByte setting CY
    pop     acc         ; restore acc
    ret             ; return to caller

; -------------------------------------------------------------------------
; stor16_r0_dptr() - store DPTR to Internal RAM (indirect via R0)
;  INPUT:
;   R0   - offset into Internal RAM of where to store 16-bit value
;   DPTR - 16-bit value to be stored
;  OUTPUTS:
;   R0 points to byte after last byte stored (ready for next 16bit store)
;  SIDE-EFFECTS:
;   iram[r0] <- DPH
;   iram[r0+1] <- DPL
stor16_r0_dptr:
    mov     @r0,dph     ; store DPH
    inc     r0          ; point to next locn
    mov     @r0,dpl     ; store DPL
    inc     r0          ; point to next locn
    ret             ; return to caller

; -------------------------------------------------------------------------
; stor16_r0_ba() - store 16bit value (in b,acc) to Internal RAM (indirect via R0)
;  INPUT:
;   R0   - offset into Internal RAM of where to store 16-bit value
;   b    - msByte of 16bit value to be stored
;   acc  - lsByte of 16bit value to be stored
;  OUTPUTS:
;   R0 points to byte after last byte stored (ready for next 16bit store)
;  SIDE-EFFECTS:
;   iram[r0] <- b
;   iram[r0+1] <- acc
stor16_r0_ba:
    mov     @r0,b       ; store DPH
    inc     r0          ; point to next locn
    mov     @r0,a       ; store DPL
    inc     r0          ; point to next locn
    ret             ; return to caller

; -------------------------------------------------------------------------
; load16_dptr_r0() - load DPTR from Internal RAM (indirect via R0)
;  INPUT:
;   R0      - offset into Internal RAM from where to load the 16-bit value
;  OUTPUT:
;   DPTR    - 16-bit value loaded from Internal RAM
;                 DPH <- iram[r0]
;                 DPL <- iram[r0+1]
;   R0      - points to byte after last byte loaded (ready for next 16bit load)
;  SIDE-EFFECTS:
;   None
load16_dptr_r0:
    mov     dph,@r0     ; load DPH
    inc     r0          ; point to next locn
    mov     dpl,@r0     ; load SUML
    inc     r0          ; point to next locn
    ret             ; return to caller

; -------------------------------------------------------------------------
; load16_ba_r0() - load b,acc from Internal RAM (indirect via R0)
;  INPUT:
;   R0   - offset into Internal RAM from where to load the 16-bit value
;  OUTPUTS:
;   b    - msByte of 16bit value just loaded
;   acc  - lsByte of 16bit value just loaded
;   R0   - points to byte after last byte loaded (ready for next 16bit load)
;  SIDE-EFFECTS:
;   None
load16_ba_r0:
    mov     b,@r0       ; store DPH
    inc     r0          ; point to next locn
    mov     a,@r0       ; store DPL
    inc     r0          ; point to next locn
    ret             ; return to caller

;
;  End of Utility Routines
;
; -------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Digitizer Interface (ADC)
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: adc.a51,v 1.32 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
;
;  I/O routines for accessing our 8 channels of analog data
;
; --------------------------------------------------------------------------
; init_adc() - place ADC in known (quiescent) state by resetting ADC
;              and setting it to low power
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys acc, ADC is quieted
;   desired channels are setup as analog, not digital
;
;   NOTE: radiation testing used ADCLK=0x1f (Max Conversion time)
;         later testing w/Bdale, Chuck we moved to 0x06
init_adc:
    clr     a
    mov     ADCON,a
    ;  set all 8 channels (p1 pins) to ADC use
    cpl     a           ; set all 8 channels (p1 pins) to ADC use
    jnb     PIPE_MODE,iadc_init_chan
    ; byte-pipe mode does not use 2 of the analog channels
    anl     a,#0xEE     ; clear AN0 and AN4: not ANALOG INPUTS in byte-pipe mode
iadc_init_chan:
    mov     ADCF,a      ; set selected channels (p1 pins) to ADC use
    ;  set our conversion clock divisor so that ADCCLK is ~125KHz
;   mov     a,#31       ; PRS=31 for X2 mode w/8MHz Xtal
    mov     a,#6        ; PRS=6 for X2 mode w/8MHz Xtal
    mov     ADCLK,a     ; ADCCLK is now 31=125k00 Hz 0=????
    ret     ; return to caller

; --------------------------------------------------------------------------
; precision_digitize() - digitize all eight channels in precision mode (12bit)
;   storing to RAM.  This routine implements averaging of 16 samples for each
;   channel.  The channels are sampled 0 thru 7 for each of 16 times.  As
;   each sample is taken, it is added to running sum in RAM for the channel.
;   After all sums are computed, a final loop divides each of these 8 sums
;   by 16.
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Processor is halted during each channel conversion, ONLY the ISR at the
;    end of the conversion fires and then wakes up processor!
;   Results are stored in RAM in an 8 element list of 16bit words, one word
;    for each channel.
;
; IMPLEMENTATION NOTE:
;   byte-pipe mode does not have AN0 or AN4 (these are digital inputs)
;   Since conversion time dominates, these channels are skipped (not converted)
;   However, for code simplicity, zeros are summed for these channels and
;   the zero totals for the channels are still shifted to divide them by 16.
;   The conversion savings leaves more cpu time for byte-pipe transfers.
;
.flag   ADEOC, acc.4        ; ADEOC while in ACC
.equ    MSK_ADEOC, 0xff-0x10
.equ    MSK_SCH, 0xff-0x07
.equ    MSK_ADAT98, 0x03
.equ    MSK_ADAT72, 0xFC
.equ    MSK_ADAT10, 0x03
.equ    BIT_ADEN, 0x20
.equ    BIT_ADSST, 0x08
.equ    BIT_PRECCVT, 0x40+BIT_ADSST

;  WARNING- while the number of samples is named, the
;           divide routines are hard coded to 16! Please
;           be sure to modify both at the same time if moving
;           off of 16...

.equ    NBR_SAMPLES, 16
;
precision_digitize:
    push    acc     ; preserve acc
    mov     a,r7    ; preserve R7
    push    acc
    mov     a,r6    ; preserve R6
    push    acc
    mov     a,r5    ; preserve R5
    push    acc
    mov     a,dpl   ; preserve dpl
    push    acc
    mov     a,dph   ; preserve dph
    push    acc
    mov     a,b     ; preserve b
    push    acc
    mov     a,r0    ; preserve R0
    push    acc

    mov     r5,#NBR_SAMPLES     ; digitize NBR samples (and average them)

    setb    EADC                ; enable ADC interrupt
    ; preserve, then set, master interrupt enable
    mov     c,EA                ; copy master interrupt enable bit to CY
    setb    EA                  ; turn on interrupts
    mov     F1,c                ; save EA (now CY) to F1
    clr     OUT5                ; (TST) strobe: pre digitize enable
    setb    OUT5

    mov     ADCON,#BIT_ADEN ;***enable ADC, clear flags
    ; need min. of 4uSec delay 'tween here and start of convert
    ;  (code below here currently is ~6uSec [8 x 750 nSec])
    ;
    ; -----------------------------------------------------
    ; Setup for a pass of digitizing all eight channels
    ;
cvt_nxpass:
    mov     r0,#adc_chan_base   ; (1) offset to channel storage
    mov     next_chan,#0        ; (1) first channel to convert
    mov     r7,#8               ; (1) number of channels to convert

    ; -----------------------------------------------------
    ; Digitize selected channel
    ;
cvt_nxchan:
    ; iff NOT pipe-mode then don't skip any channels
    jnb     PIPE_MODE,noSkipChan
    ; in Byte-pipe mode, skip two of our channels (0, 4)
    mov     a,next_chan     ; get channel nbr to be converted
ckch0:
    cjne    a,#0,ckch4      ; if not chan 0, check next...
    ; zero out analog channel 0 result
    sjmp    zeroChan        ; go zero out channel 0
ckch4:
    cjne    a,#4,ckchEnd    ; if not chan 4, check next...
    ; zero out analog channel 4 result
zeroChan:
    clr     a               ; - zero lower bits for this channel
    mov     b,a             ; - zero upper bits for this channel
    sjmp    endLoadRslt     ; go proceed with zeros as conversion result

ckchEnd:        ; here when no more channel skips to check
noSkipChan:     ; here when omitting entire channel-skip check
    mov     a,ADCON         ; (1) get copy of ADC control values
    anl     a,#MSK_SCH      ; (1) clear channel selection [bits:2-0]
    orl     a,next_chan     ; (1) set channel idx
    mov     ADCON,a         ; (1) select channel to convert
    orl     a,#BIT_PRECCVT  ; (1) select precision conversion
    clr     OUT6            ; (1) (TST) set: BEGIN channel digitize

    ;
    ; ended up with ~6.0 uSec's
    mov     ADCON,a         ;***start the conversion
    ;
    ;**********************
    ;*** ISR fires here ***
    ;**********************
    ;
    setb    OUT6            ; (TST) clear: END channel digitize

    anl     ADCON,#MSK_ADEOC    ; reset conversion complete indicator

    ; -----------------------------------------------------
    ; convert:    ADDH=98765432,   ADDL=xxxxxx10
    ;      to:       b=xxxxxx98,    acc=76543210
    mov     a,ADDH          ; get high 8 bits (ADAT9-ADAT2) [98765432]
    rl      a               ; now [87654329]
    rl      a               ; now [76543298]
    mov     r6,a            ; save [76543298] in r6
    anl     a,#MSK_ADAT98   ; now [00000098]
    mov     b,a             ; save result in b for later
    mov     a,ADDL          ; get remaining two digitized bits [??????10]
    anl     a,#MSK_ADAT10   ; now [00000010]
    xch     a,r6            ; a=[76543298], r6=[00000010]
    anl     a,#MSK_ADAT72   ; now [76543200]
    orl     a,r6            ; now [76543210], result in a
endLoadRslt:
    ; -----------------------------------------------------
    ; Save latest digitized result for channel
    ;
    ; IFF first pass for channel, simply store result versus add to result
    cjne    r5,#NBR_SAMPLES,add2chan    ; iff not 1st pass, don't init storage
stor2chan:
    ; write new sample to iRAM[r0] leaving r0 pointing to next chan storage
    acall   stor16_r0_ba    ; store b,a to InternalRAM @r0 (storage for this chan)
    sjmp    chanSaved
add2chan:
    ; add new sample to iRAM[r0] leaving r0 pointing to next chan storage
    acall   add16_r0_ba     ; add b,a to InternalRAM @r0 (storage for this chan)
chanSaved:

    ; -----------------------------------------------------
    ; go do next channel if not done all
    ;
endChan:
    inc     next_chan       ; select next channel to convert
    djnz    r7,cvt_nxchan   ; if not done, do next of 8 channels
    ;  mark end of 8-channel conversion
    clr     OUT6            ; (TST) strobe: inner sample loop
    setb    OUT6

    ; -----------------------------------------------------
    ; go do next pass if not done all
    ;
endPass:
    djnz    r5,cvt_nxpass   ; if not done, do next of NBR samples

endDigi:
    ; -----------------------------------------------------
    ; done with device for now, set to low power and return
    clr     a               ; reset ADC and set to low power
    mov     ADCON,a

    ; -----------------------------------------------------
    ; Compute average of NBR Samples acquired for all channels
    ;
    ;   each of the 8 adc words contain the sum of samples
    ;   for each, divide the sum by 16... (our NBR_SAMPLES)
    ;
    mov     r0,#adc_chan_base   ; offset to channel storage
    mov     r7,#8               ; number of channels to convert
div_nxchan:
    acall   load16_dptr_r0      ; load this channel's sum
    acall   div16_dptr_by16     ; divide sample by 16
    dec     r0                  ; point to prior storage locn
    dec     r0                  ;  (value just loaded for chan)
    acall   stor16_r0_dptr      ; store new result (in dptr) over top
    djnz    r7,div_nxchan   ; if not done, do next channel
    clr     OUT5            ; (TST) strobe: post digitize disable
    setb    OUT5
    clr     OUT5
    setb    OUT5

    clr     EADC            ; disable ADC interrupt
    ; restore interrupt context
    mov     c,F1            ; restore EA (Enabling interrupts if they were)
    mov     EA,c

    ; restore all preserved registers
    pop     acc             ; restore R0
    mov     r0,a
    pop     acc             ; restore b
    mov     b,a
    pop     acc             ; restore dph
    mov     dph,a
    pop     acc             ; restore dpl
    mov     dpl,a
    pop     acc             ; restore R5
    mov     r5,a
    pop     acc             ; restore R6
    mov     r6,a
    pop     acc             ; restore R7
    mov     r7,a
    pop     acc             ; restore ACC
    ret     ; return to caller

;
;  End of ADC handling routines
;
; -------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Memory Checksum Routines and related stuff
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: checksums.a51,v 1.34 2004/09/30 00:01:37 stephen Exp $
; --------------------------------------------------------------------------
; init_ram() - device is starting up. Either a power up or WD reset
;              has occurred. Map memories, unmap others, and init some.
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   RAM is setup ready for use. ERAM is mapped, memory is zero'd if
;   powering up for first time.
init_ram:
    anl     auxr,#0xFF-0x02 ; select Expanded XRAM space (1KB RAM)
    orl     auxr,#0x0c      ; set ERAM is 1K bytes (force default value)
    acall   sel_eram        ; ERAM mapped, EEPROM not mapped
    acall   dsa_bootrom     ; BOOT FLASH (FM1) not mapped
    acall   ck_signature    ; is our SIG still in RAM?
    jnc     ram_is_bad      ;  no, go do RAM inits, RAM is in unknown state
ram_is_good:
    ;  RAM is in good shape... tell others...
    inc     ctr_wd_resets   ; show that a WD reset occurred
    setb    ISWDSTART       ; YES, WD Expired and caused this start
    clr     OUT3        ; (tst) strobe: RAM is OK
    setb    OUT3
    ret     ; return to caller

ram_is_bad:
    clr     OUT3        ; (tst) strobe: RAM is BAD (Initial pwr on)
    setb    OUT3
    clr     OUT3
    setb    OUT3
    ; RAM is in unknown(bad) state.  Init it as if we just powered up
    acall   zero_direct_ram ; zero our direct-page RAM (flag bytes, etc.)
    acall   fill_direct_ram ; fill unused direct-page RAM with test value
    acall   fill_eram       ; TST fill ERAM with test value TST
    acall   set_signature   ; write our signature bytes mark RAM as good
    clr     a
    cpl     a               ; get all ones
    mov     outs1_cpy0,a    ; write initial config values
    mov     outs1_cpy1,a
    mov     outs1_cpy2,a
    mov     outs1_cpy3,a
    mov     outs1_cpy4,a
    mov     outs1_cpy5,a
    mov     outs1_cpy6,a
    mov     outs1_cpy7,a
    mov     outs2_cpy0,a    ; make 2nd copy equal to 1st
    mov     outs2_cpy1,a
    mov     outs2_cpy2,a
    mov     outs2_cpy3,a
    mov     outs2_cpy4,a
    mov     outs2_cpy5,a
    mov     outs2_cpy6,a
    mov     outs2_cpy7,a
    clr     ISWDSTART       ; NO, normal power on start
    ret     ;

; --------------------------------------------------------------------------
; set_signature() - place a known signature in 4 RAM locations
;   This is tested later to see if we are resetting due to WD expiration
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   four RAM locations are initialized
.equ    SIG_BYT1, 0xA6
.equ    SIG_BYT2, 0xE5
.equ    SIG_BYT3, 0xB7
.equ    SIG_BYT4, 0xF3
;
set_signature:
    mov     ramsig1,#SIG_BYT1
    mov     ramsig2,#SIG_BYT2
    mov     ramsig3,#SIG_BYT3
    mov     ramsig4,#SIG_BYT4
    ret

rqst_boot2can:
.equ    SIG_BOOT1, 0xF7
.equ    SIG_BOOT2, 0xB0
.equ    SIG_BOOT3, 0x9D
.equ    SIG_BOOT4, 0xE5
.equ    SIG_BOOT5, 0xA2
.equ    SIG_BOOT6, 0xC3
    mov     outs1_cpy0,#SIG_BOOT1   ; write initial config values
    mov     outs2_cpy3,#SIG_BOOT2
    mov     outs1_cpy1,#SIG_BOOT3
    mov     outs2_cpy4,#SIG_BOOT4
    mov     outs1_cpy2,#SIG_BOOT5
    mov     outs2_cpy2,#SIG_BOOT6
    clr     OUT4        ; (tst) strobe: request a CAN boot after WD reset
    setb    OUT4
    clr     OUT4
    setb    OUT4
    clr     OUT4
    setb    OUT4
    ret

isbootrqst:
    mov     a,outs1_cpy0
    cjne    a,#SIG_BOOT1,bad_boot
    mov     a,outs2_cpy3
    cjne    a,#SIG_BOOT2,bad_boot
    mov     a,outs1_cpy1
    cjne    a,#SIG_BOOT3,bad_boot
    mov     a,outs2_cpy4
    cjne    a,#SIG_BOOT4,bad_boot
    mov     a,outs1_cpy2
    cjne    a,#SIG_BOOT5,bad_boot
    mov     a,outs2_cpy2
    cjne    a,#SIG_BOOT6,bad_boot
good_boot:
    clr     OUT4        ; (tst) strobe: IS VALID CAN BOOT Request
    setb    OUT4
    setb    c   ; RAM checks out! tell caller
    ret
bad_boot:
    clr     OUT4        ; (tst) strobe: NOT a CAN BOOT request
    setb    OUT4
    clr     OUT4
    setb    OUT4
    clr     c   ; SIG check failed, tell caller
    ret

; --------------------------------------------------------------------------
; ck_signature() - check all four locations for good values. if any one is
;   not a match then consider the RAM not setup (this is a power on?) and
;   inform caller.
; INPUTS:
;   None
; OUTPUTS:
;   cy is set if RAM is good, is cleared if RAM is bad
; SIDE-EFFECTS:
;   destroys acc
;   four RAM locations were read and checked against expected values
ck_signature:
    mov     a,ramsig1
    cjne    a,#SIG_BYT1,bad_ram
    mov     a,ramsig2
    cjne    a,#SIG_BYT2,bad_ram
    mov     a,ramsig3
    cjne    a,#SIG_BYT3,bad_ram
    mov     a,ramsig4
    cjne    a,#SIG_BYT4,bad_ram
good_ram:
    setb    c   ; RAM checks out! tell caller
    ret
bad_ram:
    clr     c   ; SIG check failed, tell caller
    ret

; --------------------------------------------------------------------------
; sel_eeprom() - map EEPROM to XRAM memory space not Expanded RAM
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   EEPROM is now accessable...
sel_eeprom:
    orl     eecon,#0x02         ; map EEPROM to XRAM space (OVERLAY EEPROM)
    ret

; --------------------------------------------------------------------------
; sel_eram() - map Expanded RAM to XRAM memory space not EEPROM
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Epanded RAM is now accessable...
sel_eram:
    anl     eecon,#0xff-0x02    ; unmap EEPROM (Kill EEPROM overlay)
    ret

; --------------------------------------------------------------------------
; ena_bootrom() - map boot ROM (FM1) into code space at f800-ffff (enable)
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Boot ROM is now accessable... (in code space)
;   NOTE: this is for code execution ONLY, the boot space can not be read..??
ena_bootrom:
    push    acc
    mov     a,r2
    orl     auxr1,#0x20         ; map FM1 into code space
    mov     r2,#10              ; need delay here... not sure how much... 10 for now...
waitOnRom:
    djnz    r2,waitOnRom        ; delay is 10 x (2 Instru times per iteration)
    mov     r2,a
    pop     acc
    ret

; --------------------------------------------------------------------------
; dsa_bootrom() - remove boot ROM from code space (disable)
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Boot ROM is no-longer accessable...
dsa_bootrom:
    anl     auxr1,#0xff-0x20    ; unmap FM1 from code space
    ret

; -------------------------------------------------------------------------
; sum_memory() - sum each memory region and record sums in direct ram
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys CY flag, F1 flag
;   sums are stored in RABoot ROM is no-longer accessable...
sum_memory:
    ; preserve then clear interrupt context
    mov     c,EA        ; get master interrupt enable bit
    clr     EA          ; turn off interrupts
    mov     F1,c        ; save EA
    ; generate and store sums
    acall   sum_flash
    acall   sum_ram
    acall   sum_eeprom
    acall   sum_bootflash
    acall   sum_eram
    ; restore interrupt context
    mov     c,F1        ; restore EA (Enabling interrupts if they were)
    mov     EA,c
    ret ; return to caller

; -------------------------------------------------------------------------
; zero_direct_ram() - write zero's to all of direct RAM
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys  acc,r0,r2
;   Entire usable RAM (less indirect space) is zero'd
zero_direct_ram:
    mov     r0,#ram_bits_start  ; base address of direct ram bit flags
    mov     r2,#ram_lenwbits    ; number of bytes to zero
    clr     a                   ; get fill value
zero_dirram:
    mov     @r0,a               ; write fill byte
    inc     r0                  ; point next location
    djnz    r2,zero_dirram      ; if not done, go do another
    ret ; return to caller

; -------------------------------------------------------------------------
; fill_direct_ram() - fill unused direct RAM with known values
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys  acc,r0,r2
;   a fixed pattern is written to bytes not used by code
;   this can later be checksummed and monitored
fill_direct_ram:
    mov     a,#ram_free     ; if no spare bytes, exit
    jz      nothing2fill
    mov     r2,a            ; munber of bytes to fill
    mov     r0,#ram_1stfree ; base address of unused RAM
    mov     a,r0            ; get fill value
    cpl     a               ; invert it (so can't be confused with address value)
fill_dirram:
    mov     @r0,a           ; write fill byte
    inc     r0              ; point next location
    inc     a               ; get next fill value
    djnz    r2,fill_dirram  ; if not done, go do another
nothing2fill:
    ret ; return to caller

; -------------------------------------------------------------------------
; fill_eram() - fill ERAM with known values (bottom half of FLASH BOOT ROM)
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys  dptr, r0, and acc
fill_eram:
    acall   sel_eram        ; map ERAM to xdata memory space
    acall   ena_bootrom     ; map BOOT FLASH
    ; setup params defining the space to be summed and where to store result
    anl     auxr1,#SEL_DPTR0    ; ensure using DPTR0 for address of BOOTFLASH
    mov     dptr,#0xf800        ; DPTR0 = memory region base addr
    mov     endaddr_msb,#0x04   ; EndAddress MSByte: ERAM 0000-03ff (1past=0400)
    mov     r0,#bootflash_cksum ; store result here
    orl     auxr1,#SEL_DPTR1    ; ensure using DPTR1 for address of ERAM
    mov     dptr,#0x0000        ; DPTR1 = memory region base addr
next_byte:
    anl     auxr1,#SEL_DPTR0    ; point to BOOTFLASH
    clr     a
    movc    a,@a+dptr           ; a = code[dptr]
    inc     dptr
    orl     auxr1,#SEL_DPTR1    ; point to ERAM
    movx    @dptr,a             ; data[dptr] = a
    inc     dptr
    mov     a,dph           ; if not past end of ERAM, go do another
    cjne    a,endaddr_msb,next_byte
    acall   dsa_bootrom ; unmap BOOT FLASH
    ; no need to UNMAP the ERAM
    ret ; return to caller
;
; -------------------------------------------------------------------------
; boot2eeprom() - write BOOT FLASH (FM1) content to EEPROM
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys  ...
boot2eeprom:
    ; preserve then clear interrupt context
    mov     c,EA        ; get master interrupt enable bit
    clr     EA          ; turn off interrupts
    mov     F1,c        ; save EA
    ; map our desired regions of memory
    acall   sel_eeprom  ; map EEPROM to xdata memory space
    acall   ena_bootrom ; map BOOT FLASH
    ; ensure EEPROM device not busy
eebusy:
    mov     diag_loopid,#LPID_EEBUSY   ; LOOP:wtg for EEPROM to be not busy
eebusylp:
    mov     a,EECON         ; get status: is busy
    jb      acc.0, eebusylp ; yes, loop ...until not
    clr     diag_loopid     ; show that we are no longer in a tight-loop
    ; copy boot FLASH (FM1) to EEPROM, writing each 128 bytes page as we do so
    ; setup params defining the space to be copied and where to store result
    anl     auxr1,#SEL_DPTR0    ; ensure using DPTR0 for address of BOOTFLASH
    mov     dptr,#0xf800        ; DPTR0 = memory region base addr
    orl     auxr1,#SEL_DPTR1    ; ensure using DPTR1 for address of EEPROM
    mov     dptr,#0x0000        ; DPTR1 = memory region base addr
    ; write 16 pages
    mov     r2,16           ; number of 128 bytes pages to be written
wrnxtpag:
    ; write 128 bytes
    mov     r3,128          ; number of bytes to be written (this page)
wrnxtbyt:
    anl     auxr1,#SEL_DPTR0    ; point to BOOTFLASH
    clr     a                   ; have to use offset, zero it!
    movc    a,@a+dptr           ; READ BYTE: a = code[dptr]
    inc     dptr                ;  point to next BOOTFLASH locn
    orl     auxr1,#SEL_DPTR1    ; point to EEPROM
    movx    @dptr,a         ; WRITE BYTE: data[dptr] = a
    inc     dptr            ;  point to next EEPROM locn
    ; ...byte copied, 'nother byte?
    djnz    r3,wrnxtbyt     ; not done? go copy next byte
    ; commit (write) the 128 bytes to EEPROM
    mov     EECON, #0x52    ; strobe the EEPROM controller (write page)
    mov     EECON, #0xA2
    ; wait for write to complete...
eerwdone:
    mov     diag_loopid,#LPID_EEWRTDON   ; LOOP:wtg for EEPROM wrt to complete
eerwdnlp:
    mov     a,EECON         ; get status
    jb      acc.0, eerwdnlp ; no, loop ... until complete
    clr     diag_loopid     ; show that we are no longer in a tight-loop
    ; page written, 'nother page?
    djnz    r2,wrnxtpag     ; not done? go copy next page
    ; unmap regions of memory we no longer need
    acall   dsa_bootrom     ; unmap BOOT FLASH
    ; restore interrupt context
    mov     c,F1            ; restore EA (Enabling interrupts if they were)
    mov     EA,c
    ret ; return to caller

; -------------------------------------------------------------------------
; show_sums() - display result of sum calculations
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   The checksums are displayed out the Serial port
show_sums:
    ret ; return to caller

; -------------------------------------------------------------------------
; check upper two memory regions, leaving indicators that cksum is OK
chk_sums:
    ; check BOOTFLASH fixed value
chk_boot:
    mov     r0,#bootflash_cksum
    ; #Z# -> TODO remove hard code value
    mov     dph,#0x67
    mov     dpl,#0xdd
    acall   cmp16_r0_dptr
    setb    BOOT_OK     ; set our RAM bit flag
    jz      chk_eram
    clr     BOOT_OK     ; clear our RAM bit flag
    ; check ERAM fixed value
chk_eram:
    mov     r0,#eram_cksum
    ; #Z# -> TODO remove hard code value
    mov     dph,#0x92
    mov     dpl,#0x11
    acall   cmp16_r0_dptr
    setb    ERAM_OK     ; set our RAM bit flag
    jz      chk_end
    clr     ERAM_OK     ; clear our RAM bit flag
chk_end:
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM WORDs in CODE space
;  INPUT:
;    DPTR0       - base address of array of WORDs to be summed
;    endaddr_msb - upper byte of (last address+1) [end of range]
;  OUTPUT:
;    DPTR1       - 2's complement of SUM value
;  SIDE-EFFECT:
;    destroys acc,b,DPTR0,DPTR1
sum_codewords:
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    mov     dptr,#0     ; set initial sum value
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
sum_codeloop:
    clr     a           ; a (offset) = 0
    movc    a,@a+dptr   ; a = mem[0]
    inc     dptr        ; point next byte
    mov     b,a         ; now b = mem[0]
    clr     a           ; a (offset) = 0
    movc    a,@a+dptr   ; a = mem[1]
    inc     dptr        ; point next byte
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    acall   add16_dptr_ba       ; add b,acc to dptr
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
    mov     a,dph               ; get HIGH byte of next address
    cjne    a,endaddr_msb,sum_codeloop ; if NOT matches end+1 we go do more..
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    acall   dptr_2compl         ; 2's complement the result and return to caller
    acall   stor16_r0_dptr      ; store our new sum
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM WORDs in XDATA space
;  INPUT:
;    DPTR0          - base address of array of WORDs to be summed
;    endaddr_msb    - upper byte of (last address+1) [end of range]
;  OUTPUT:
;    DPTR1  - 2's complement of SUM value
;  SIDE-EFFECT:
;    destroys acc,b,DPTR0,DPTR1,CY
sum_datawords:
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    mov     dptr,#0     ; set initial sum value
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
sum_dataloop:
    movx    a,@dptr     ; a = mem[0]
    inc     dptr        ; point next byte
    mov     b,a         ; now b = mem[0]
    movx    a,@dptr     ; a = mem[1]
    inc     dptr        ; point next byte
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    acall   add16_dptr_ba   ; add b,acc to dptr
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
    mov     a,dph       ; get HIGH byte of next address
    cjne    a,endaddr_msb,sum_dataloop ; if NOT matches end+1 we go do more..
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1), our SUM
    acall   dptr_2compl ; 2's complement the result and return to caller
    acall   stor16_r0_dptr  ; store our new sum
    anl     auxr1,#SEL_DPTR0    ; revert back to DPTR0
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM the free-bytes in RAM
;  USES:
;   DPTR1   16-bit sum
;   a,b 16-bit word to be added to sum
;   F0  FLAG: if set, we are summing odd number of bytes
;              (n words plus 1 extra byte)
;   R1  number of WORDs to be summed (+1 iff odd, initial, byte count)
;   R0  pointer to RAM to sum, then pointer to checksum result WORD
;  INPUT:
;   None
;  OUTPUT:
;   None
;  SIDE-EFFECT:
;   destroys acc,b,r0,r1,DPTR1,CY
;   checksum is written to RAM[ram_cksum]
sum_ram:
    mov     c,F0
    mov     acc.0,c
    push    acc     ; SAVE F0
    orl     auxr1,#SEL_DPTR1    ; select alternate dptr set (DPTR1)

    mov     r0,#ram_1stfree ; r0 = memory region base addr
    mov     a,#ram_free ; get length
    mov     c,acc.0     ; get odd-length indicator
    mov     F0,c        ; set f0: f0=1 means we are doing odd nbr of bytes
    rr      a           ; convert to 16 bit word count
    mov     r1,a
    mov     dptr,#0     ; start with zero sum value
    jnb     F0,sum_iram_words ; if even nbr of bytes go do only words
; starting with odd number of bytes, assume mem[0] was zero and
;  start sum with mem[1]
    clr     a           ; odd start addr, need zero for mem[0]
    mov     b,a
    inc     r1          ; bump counter for extra "faked" word
    sjmp    sum_lowhalf ; start at second half of word summing
sum_iram_words:
    mov     b,@r0       ; b = mem[0]
    inc     r0          ; point next byte
sum_lowhalf:
    mov     a,@r0       ; a = mem[1]
    inc     r0          ; point next byte
    acall   add16_dptr_ba   ; add b,acc to dptr
    djnz    r1,sum_iram_words ; do another if not yet done
    acall   dptr_2compl ; 2's complement
    mov     r0,#ram_cksum   ; place to store result
    acall   stor16_r0_dptr  ; store our new sum

    anl     auxr1,#SEL_DPTR0    ; revert back to original dptr value: DPTR0
    pop     acc     ; RESTORE F0
    mov     c,acc.0
    mov     F0,c
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM the 32K USER FLASH (FM0) memory
;  USES:
;   DPTR0  pointer to flash memory
;   DPTR1  16-bit sum
;   a,b    16-bit word to be added to sum
;   CY     temporary bit storage
;   R0     pointer to checksum result WORD
;  INPUT:
;   None
;  OUTPUT:
;   None
;  SIDE-EFFECT:
;   destroys acc,b,DPTR0,DPTR1,CY,F1,R0
;   checksum is written to RAM[flash_cksum]
sum_flash:
    ; flash is already mapped, so no mapping code here
    ; setup params defining the space to be summed and where to store result
    anl     auxr1,#SEL_DPTR0    ; ensure using DPTR0 for address of Memory to be summed
    mov     dptr,#0             ; DPTR0 = memory region base addr
    mov     endaddr_msb,#0x40   ; EndAddress MSByte:FLASH 0000-3fff (1past=4000)
    mov     r0,#flash_cksum     ; store result here
    acall   sum_codewords       ; sum the WORDs of code space & store result in RAM
    ; no unmapping needed...
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM the 2K BOOT FLASH (FM1) memory
;  USES:
;   DPTR0  pointer to flash memory
;   DPTR1  16-bit sum
;   a,b    16-bit word to be added to sum
;   CY     temporary bit storage
;   R0     pointer to checksum result WORD
;  INPUT:
;   None
;  OUTPUT:
;   None
;  SIDE-EFFECT:
;   destroys acc,b,DPTR0,DPTR1,CY,F1,R0
;   checksum is written to RAM[bootflash_cksum]
sum_bootflash:
    acall   ena_bootrom     ; BOOT FLASH must be mapped
    ; setup params defining the space to be summed and where to store result
    anl     auxr1,#SEL_DPTR0    ; ensure using DPTR0 for address of Memory to be summed
    mov     dptr,#0xf800        ; DPTR0 = memory region base addr
    mov     endaddr_msb,#0x00   ; EndAddress MSByte: FLSH f800-ffff (1past=0000)
    mov     r0,#bootflash_cksum ; store result here
    acall   sum_codewords   ; sum the WORDs of code space & store result in RAM
    acall   dsa_bootrom     ; unmap BOOT FLASH
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM the 2K EEPROM
;  USES:
;   DPTR0  pointer to EEPROM memory
;   DPTR1  16-bit sum
;   a,b    16-bit word to be added to sum
;   CY     temporary bit storage
;   R0     pointer to checksum result WORD
;  INPUT:
;   None
;  OUTPUT:
;   None
;  SIDE-EFFECT:
;   destroys acc,r0,r1,a,b,DPTR0,DPTR1,r6,r7
;   checksum is written to RAM[eeprom_cksum]
sum_eeprom:
    acall   sel_eeprom      ; map EEPROM into XRAM memory space
    ; setup params defining the space to be summed and where to store result
    anl     auxr1,#SEL_DPTR0 ; ensure using DPTR0 for address of Memory to be summed
    mov     dptr,#0         ; DPTR0 = memory region base addr
    mov     endaddr_msb,#0x08 ; EndAddress MSByte:EEPROM 0000-07ff(1past=0800)
    mov     r0,#eeprom_cksum ; store result here
    acall   sum_datawords   ; sum WORDs of data space & store result in RAM
    acall   sel_eram        ; unmap EEPROM from XRAM space
    ret ; return to caller

; -------------------------------------------------------------------------
; SUM the 1K ERAM
; USES:
;   DPTR0  pointer to ERAM memory
;   DPTR1  16-bit sum
;   a,b    16-bit word to be added to sum
;   CY     temporary bit storage
;   R0     pointer to checksum result WORD
; SIDE-EFFECT:
;   destroys acc,r0,r1,a,b,DPTR0,DPTR1,r6,r7
sum_eram:
    ; Ensure ERAM is mapped into XRAM space
    acall   sel_eram
    ; setup params defining the space to be summed and where to store result
    anl     auxr1,#SEL_DPTR0    ; ensure using DPTR0 for address of Memory to be summed
    mov     dptr,#0         ; DPTR0 = memory region base addr
    mov     endaddr_msb,#0x04   ; EndAddress MSByte: ERAM 0000-03ff (1past=0400)
    mov     r0,#eram_cksum      ; store result here
    acall   sum_datawords   ; sum WORDs of data space & store result in RAM
    ; no unmapping needed...
    ret ; return to caller

;
;  End of Memory Sum Routines
; -------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Shift Register handler
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: shift-reg.a51,v 1.23 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
;
;  I/O routines for accessing 74HC165 Shift Register which
;    is our access to address and mode bits on CAN Widget
;
;  The 74HC165 is hung off of port-3 bits 4,5 and 6.
;
;  The parallel side of the register is connected to
;  a header on the Widgets: JP1-8 with meaning:
;
;     Jumper     Purpose    SR-BIT
;    --------   ---------   ------
;     JP1        Mode 1       D7
;     JP2        Mode 0       D6
;
;     JP3        Addr 5       D5
;     JP4        Addr 4       D4
;     JP5        Addr 3       D3
;     JP6        Addr 2       D2
;     JP7        Addr 1       D1
;     JP8        Addr 0       D0
;    --------   ---------   ------
;
;  Timing Note: This 74HC165 device has setup and hold
;   timings/propagation delays measured in 10's of nSeconds. [7-60]
;   Our processor (clocked at 8Mhz) has a single instruction time
;   of 750+ nSec.  Therefore, our narrowest pulse width is 750+ nSec
;   when we use the set-bit and clear-bit instructions.  As a result
;   we are not concerned with our interacting with this device at
;   our maximum possible rate.
;
;   These Timings are shown for -40 to +125 degrees Celcius
;   (ambient temperature) in the Phillips data sheet dated
;   December 1990.
;
;.org   code_page3  ; this code starts here
;
; -------------------------------------------------------------------------
.equ    SR_CTL_BITS, 0x70

; --------------------------------------------------------------------------
; init_sr() - place SR in known (quiescent) state
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   SR control bits are placed in known state
init_sr:
    orl     P3,#SR_CTL_BITS     ; SR_CLK, SR_LOAD and SR_DATA
    ret

; --------------------------------------------------------------------------
; read_sr() - Read the SR placing SR D7-D0 into ACC.7-0 (matched order)
; INPUTS:
;   None
; OUTPUTS:
;   acc - address and mode bits as read from the SR
; SIDE-EFFECTS:
;   None
;    NOTE: Our clock is slow enough that this needs NO wait states
read_sr:
    mov     a,r7        ; get r7
    push    acc     ; save r7 to stack

    mov     r7,#8       ; number of bits to read
    ;  cause SR to load the jumper settings
    setb    SR_CLK      ;  make clock high to ensure stable load
    clr     SR_LOAD     ;  strobe load line
    setb    SR_LOAD
    ;  loop reading 8 bits of SR contents
next_bit:
    ;  read data bit value
    mov     c,SR_DATA   ; copy bit to cy
    rlc     a           ; cy to D0, D0->D1, etc.
    ;  shift the data
    clr     SR_CLK      ; start pulse
    setb    SR_CLK      ; end pulse
    ;  jump to do next bit if not done
    djnz    r7,next_bit
    mov     r7,a        ; save acc

    pop     acc     ; restore r7 from stack
    xch     a,r7        ; put both in proper loc'n
    mov     mod_bits,a  ; write raw value to RAM, too
    ret ; w/c(acc) as jumper values...

; --------------------------------------------------------------------------
; load_config() - retrieve the SR value and split out into two values
;                 saving each in proper place in RAM
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Sets up RAM variables:
;     mod_addr     - with address bits             (0x3f bits are valid)
;     mod_mode     - with mode bits, right aligned (0x03 bits are valid)
;     MUX_MODE  - BOOL - T=in mux mode, F=not in mux mode
;     PIPE_MODE - BOOL - T=in pipe mode, F=not in pipe mode
load_config:
    ; save context
    push    acc ; preserve accum
    mov     a,r7    ; preserve R7
    push    acc

    acall   read_sr ; read the jumper settings
    mov     r7,a    ; save a copy [MMaaaaaa]
    anl     a,#0x3f ; isolate address field [00aaaaaa]
    mov     mod_addr,a ; save Addr in RAM
    mov     a,r7    ; get the copy [MMaaaaaa]
    rl      a   ; now [MaaaaaaM]
    rl      a   ; now [aaaaaaMM]
    anl     a,#0x03 ; isolate mode value [000000MM]
    mov     mod_mode,a ; save Mode in RAM
    ; setup bit for MODE check
    clr     MUX_MODE    ; preset No, we are NOT in Multiplex mode
    cjne    a,#MODE_MUX,not_mux
    setb    MUX_MODE    ; yes, we are Multiplex mode
not_mux:
    ; setup bit for MODE check
    clr     PIPE_MODE   ; preset No, we are NOT in Byte-pipe mode
    cjne    a,#MODE_PIPE,ldcfgexit
    setb    PIPE_MODE   ; yes, we are Byte-pipe mode
ldcfgexit:
    ; restore context
    pop     acc ; restore original R7
    mov     r7,a
    pop     acc ; restore original acc
    ret     ; return to caller
;
;  End of SR handling routines
;
; -------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Byte-pipe Input/Output Watch Dogs
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: pipe-wd.a51,v 1.8 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------
;
;  The pipe-Input and Output timers are two PCA channels (0, 1)
;   clocked from Timer-0.
;
;  THEORY OF OPERATION:
;   Timer0 clocked at 7.9KHz feeds the PCA subsystem.
;   The PCA Timer, clocked from Timer0, continuously runs.
;    a 'tic' for this timer is 125 uSec (or 167 instruction cycle times)
;   Two channels (0, 1) are setup as 16-bit comparators.
;
;   Enabling a pipe 8-byte timer means setting up the comparator for
;   the channel to match ~2 mSec from now. [See: ena_...() below]
;
;   When a match occurs, an interrupt is generated marking the
;   transfer as unsuccessful.
;
;   A successful transfer _must_ prevent this from happening.
;    [See: disa_...() below]
;
;
;.org   code_page3  ; this code starts here
;
; -------------------------------------------------------------------------
; for TCON:
.equ    MSK_DSA_TR0,0xff-0x10
.equ    MSK_DSA_TR1,0xff-0x40
; for TMOD:
.equ    T0_MODE2, 0x02
.equ    MSK_T0_TIMER,0xff-0x04
.equ    MSK_TR0_ENA,0xff-0x08
.equ    T1_MODE2, 0x20
.equ    MSK_T1_TIMER,0xff-0x40
.equ    MSK_TR1_ENA,0xff-0x80
.equ    MSK_T0_SETUP,0xff-0x0f  ; clear to setup + clear mode field
; for T[HL]0:
.equ    T0_RESET_VAL, 0xff-166  ;7K9 Hz (This amounts to 166+1 or 167 tics)
; for CKCON:
.equ    MSK_T0_X2,0xff-0x02
; for CMOD:
.equ    MSK_PCA_SETUP,0xff-0x4D ; no WD, Clr SLCT, no INTRPT
.equ    STOP_DURIDL,0x80
.equ    SLCT_T0,0x04
; for CCAPM[0-4]:
.equ    ECOM,0x40
.equ    MAT,0x08
.equ    ECCF,0x01
.equ    MSK_NOECCF_ORMAT,0xff-(ECCF+MAT)

; --------------------------------------------------------------------------
; init_pipeWDs() - configure two pipe timers, leaving them disabled
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   Timer-0 is setup and running,
;   PCA Channels 0 and 1 are configured and ready to
;      be controlled by the pipe-I/O statemachine
init_pipeWDs:
; setup timer-0
    ; IEN0:ET0 Make sure TF0 doesn't interrupt, ever (not needed)
    clr     ET0
    ; TCON:TR0 disable Timer-0
    clr     TR0
    ; CKCON:T0X2 select 8MHz feed to tmr-0 vs. 4MHz
    anl     CKCON,#MSK_T0_X2
    ; TMOD:GATE0,C/T0#,M10,M00 T0 in mode 2 (8-bit w/auto-reload)
    anl     TMOD,#MSK_T0_SETUP
    orl     TMOD,#T0_MODE2
    ; TL0,TH0: set init cnt for T0 to be (255 - 64), reload=same
    mov     TL0,#T0_RESET_VAL
    mov     TH0,#T0_RESET_VAL
; setup PCA-subsystem
    ; disable PCA during precision ADC work, set CLK source as T0
    mov     CMOD,#STOP_DURIDL+SLCT_T0
    ; enable comparator for pipe-in timer (PCA-chan0)
    mov     CCAPM0,#ECOM
    ; enable comparator for pipe-out timer (PCA-chan1)
    mov     CCAPM1,#ECOM
; start the CLOCKs
    ; CCON:CR enable the PCA-subsystem clock
    setb    CR
    ; IEN0:EC enable the PCA-subsystem interrupts
    setb    EC
    ; TCON:TR0 enable timer-0
    setb    TR0
    ; NOTE: nothing happens, now, until ena_ routine (below) is called
    ret ; return to caller

; --------------------------------------------------------------------------
; ena_pipein() - start the pipe-input timer running
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   PCA Channel zero will now interrupt at the specified interval
;   (unless it is shut off by then)
ena_pipein:
    ; mark pipe channel as active
    setb    PIPEINBUSY      ; this channel (PIPE IN) is busy
    ; Set match period for 2 mSec from now
    mov     a,#16           ; which is 16 pca-timer tic's from now...
    add     a,CL            ; Add 'A' To CL
    mov     CCAP0L,a        ; Move Result To compare-reg-low
    mov     a,CH            ; Get CH
    addc    a,#0        ; If Carry Set, This Will Increment
    mov     CCAP0H,a        ; Move Result to compare-reg-high
    ; clear current, if any, attempt to notify
    clr     PIPEINEXP       ; this timer has not yet expired
    clr     CCF0
    ; allow the device to notify
    orl     CCAPM0,#ECCF+MAT
    ret ; return to caller

; --------------------------------------------------------------------------
; ena_pipeout() - start the pipe-output timer running
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   PCA Channel one will now interrupt at the specified interval
;   (unless it is shut off by then)
ena_pipeout:
    ; mark pipe channel as active
    setb    PIPEOUTBUSY     ; this channel (PIPE OUT) is busy
    ; Set match period for 2 mSec from now
    mov     a,#16           ; which is 16 pca-timer tic's from now...
    add     a,CL            ; Add 'A' To CL
    mov     CCAP1L,a        ; Move Result To compare-reg-low
    mov     a,CH            ; Get CH
    addc    a,#0        ; If Carry Set, This Will Increment
    mov     CCAP1H,a        ; Move Result to compare-reg-high
    ; clear current, if any, attempt to notify
    clr     PIPEOUTEXP      ; this timer has not yet expired
    clr     CCF1
    ; allow the device to notify
    orl     CCAPM1,#ECCF+MAT
    ret ; return to caller

; --------------------------------------------------------------------------
; disa_pipein() - disable the pipe-input timer, the transfer completed!
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   PCA Channel zero will no longer be a factor until next started
disa_pipein:
    ; prevent the device from notifying
    anl     CCAPM0,#MSK_NOECCF_ORMAT
; clear current, if any, attempt to notify
    clr     CCF0
    ; mark pipe channel as INactive
    clr     PIPEINBUSY      ; this channel (PIPE IN) is NOT busy
    ret ; return to caller

; --------------------------------------------------------------------------
; disa_pipeout() - disable the pipe-output timer, the transfer completed!
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   PCA Channel one will no longer be a factor until next started
disa_pipeout:
    ; prevent the device from notifying
    anl     CCAPM1,#MSK_NOECCF_ORMAT
    ; clear current, if any, attempt to notify
    clr     CCF1
    ; mark pipe channel as INactive
    clr     PIPEOUTBUSY     ; this channel (PIPE OUT) is NOT busy
    ret ; return to caller

;
;  End of pipe-timer handling routines
;
; -------------------------------------------------------------------------
; -------------------------------------------------------------------------
; AMSAT Module CAN Interface - Hardware Watch-dog Interface (WD)
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: wd.a51,v 1.5 2004/09/21 05:18:54 stephen Exp $
; -------------------------------------------------------------------------
;
;  I/O routines for manipulating our hardware watchdog and behavior
;   associated with a watch-dog expiration.
;
; -------------------------------------------------------------------------
; init_wd() - place WD in operating state
;
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   destroys cy, H/W WD is now configured and running
init_wd:
    mov     WDTPRG,#0x07    ; select Max timeout value
    ;-------------------------------------------------------
    ;              NOTE NOTE NOTE NOTE
    ; !!!fall through into following reset-wd() routine!!!
    ;-------------------------------------------------------

; -------------------------------------------------------------------------
; reset_wd() - poke WD so it restarts its timer
;    (indicating that "We are still running OK")
;
;   NOTE: use this same sequence to initially start WD running
;
; INPUTS:
;   None
; OUTPUTS:
;   None
; SIDE-EFFECTS:
;   WD now restarts counting from beginning
;   CY is destroyed
reset_wd:
    ; preserve then clear interrupt context
    mov     c,EA        ; get master interrupt enable bit
    clr     EA          ; turn off interrupts
    ; reset H/W Watch-dog timer
    mov     WDTRST,#0x1E    ; set value
    mov     WDTRST,#0xE1    ; set value
    ; restore interrupt context
    mov     EA,c
    ret     ; return to caller

;
;  End of WD handling routines
;
; -------------------------------------------------------------------------
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - Message for main()
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: main-msgs.a51,v 1.4 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------

;
;  End of main-messages
;
; --------------------------------------------------------------------------
; AMSAT Module CAN Interface - CAN I/O Debug Messages
; Copyright (C) 2002-2004 by Stephen Moraco, KC0FTQ
; $Id: canio-msgs.a51,v 1.3 2004/09/29 07:49:31 stephen Exp $
; --------------------------------------------------------------------------

;
;  End of CAN I/O Messages
; --------------------------------------------------------------------------
;
.equ    rom_1stfree, *
.equ    rom_free, rom_top - rom_1stfree + 1 - 2
.equ    rom_len, rom_top + 1

; check-work is last two bytes of ROM!!
        .org    code_pageF + 2048 - 2
; -------------------------------------------------------------------------
;    The following word will contain 0xDEAD until the flasher utility
;    is taught to calculate and place the inverted bit sum in its place.
;
;    Once this is done, summing the entire ROM should always result in
;    a ZERO sum!  (New power-on runtime check!)
; -------------------------------------------------------------------------
rom_chkword:
.byte   0xDE
.byte   0xAD
    .end
; -------------------------------------------------------------------------
;   End of assembler source file
; -------------------------------------------------------------------------
